
#include "StdBasics.hh"

double discount, step_size, max_rand_param, td_discount;
int steps_per_epoch, max_rl_steps, max_rl_time, nn_layers, approx_outputs;
char *param_file;


// Now read the input specification from command line
// At this stage, we just extract the parameters for RL.
// The parameters for tree sampler will be read by CRFBasic internally.
void parse_para(int *argc, char **argv)
{
	char *buffer;

	Utility::get_arg(&steps_per_epoch, argc, argv, "-spe", 2, DFT_STEPS_PER_EPOCH);
	Utility::get_arg(&max_rl_steps, argc, argv, "-xs", 2, DFT_MAX_RL_STEP);
	Utility::get_arg(&max_rl_time, argc, argv, "-xt", 2, DFT_MAX_RL_TIME);
	Utility::get_arg(&nn_layers, argc, argv, "-ly", 2, DFT_NN_LAYERS);
	Utility::get_arg(&approx_outputs, argc, argv, "-xo", 2, DFT_APPROX_OUTPUTS);
	Utility::get_arg(&discount, argc, argv, "-dc", 2, DFT_DISCOUNT);
	Utility::get_arg(&step_size, argc, argv, "-ss1", 2, DFT_STEP_SIZE);
	Utility::get_arg(&td_discount, argc, argv, "-td", 2, DFT_TD_DISCOUNT);

	param_file = NULL;
	Utility::get_arg(&param_file, argc, argv, "-pf", 2, DFT_PARAM_FILE);

	buffer = new char [strlen(param_file) + 20];
	sprintf(buffer, "%s_%d", param_file, getpid());
	delete [] param_file;
	param_file = buffer;
	printf("%s\n", param_file);

	if (max_rl_steps)
		cout<<"max_rl_steps set to "<<max_rl_steps<<endl;
	if (max_rl_time)
		cout<<"max_rl_time set to "<<max_rl_time<<endl;
}


