#ifndef LookupTableBatch_hh
#define LookupTableBatch_hh
// $Id: LookupTableBatch.hh 29 2006-12-19 02:16:20Z daa $

namespace libpg {
/**
 * A version of neural network that supports aggregated gradients
 */

class LookupTableBatch : public LookupTable {

protected:

    Matrix grads;
    LookupTableBatch() {};

public:



    LookupTableBatch(int observations, int outputs);
    
    virtual void batchStep();
    virtual void computeDirection(int steps);
    virtual void accumulateGrad(double reward, Observation& newObs);
    virtual void resetGrad();

    virtual void scatter(Vector& v, Approximator::StatsEnum s);
    virtual void reduce(Vector& v, Approximator::StatsEnum s);
};
}
#endif
