// $Id$

class MixedController : public libpg::Controller {

protected:

  libpg::NeuralNet* approximator;
  libpg::Controller* trainer_controller;
  libpg::Controller* approx_controller;

  int inputs;
  double statistics[PHASES];
  int time;
  int training_time; // how long we use SCATS to train the NN
  int trainer_dim;
  int approx_dim;
  Vector reward;

  void MixedController::get_action_from_subcontroller(
    Controller* controller, libpg::Observation& obs, Vector& action,  
    int split_from, int split_to, bool learn); 
  void MixedController::train_approximator(libpg::Observation& obs, Vector& action);
 
public:

  MixedController(libpg::NeuralNet* nn, libpg::Controller* ac, libpg::Controller* tc, int train_time);
  virtual ~MixedController() {} 

  virtual void getAction(libpg::Observation& obs, Vector& action, 
			 bool computeGrad = false);
  //virtual void getMostProbAction(libpg::Observation& obs, libpg::Vector& action);

  virtual int getInputDim();
  virtual void discountTrace() { approximator->discountTrace(); }
  virtual void setDiscount(double discount) {approximator->setDiscount(discount);}
  //virtual void accumulateGrad(double reward);
  virtual void instantStep(Vector& reward);
  //virtual void instantStep(libpg::Vector& reward, libpg::Observation& newObs) {}
  //virtual void batchStep();
  virtual void setStepSize(double stepSize) { approximator->setStepSize(stepSize);}


  virtual void resetTrace() { approximator->resetTrace(); }
  virtual void resetParams() { approximator->resetParams(); }
  virtual void randomizeParams(double maxRand) { approximator->randomizeParams(maxRand); }
  virtual double getMaxParam() { return approximator->getMaxParam(); }
  virtual int getNumParams() { return approximator->getNumParams(); }
  virtual void write(ostream& o); // NYI, left blank so it would run.
  virtual void read(istream& o); // NYI, left blank so it would run.
};
