// $Id: makeOptionsFromDefines.hh.template,v 1.4 2004/06/01 01:23:29 daa Exp $ 
// Automatically generated by makeOptionsFromDefines. Do not edit directly.

class Ps {

 private:

    typedef enum OptionTypeEnum { 
	PsBool,
	PsDouble, 
	PsInt, 	
	PsString 
    } OptionType;

    typedef struct OptionReflectStruct {
	char* name;
	char* help;  // Info about this variable
	OptionType type; 
	void* val;   // Pointer to variable in this class;
    } OptionReflect;

    static OptionReflect reflections[];

 public:

    // List of parameters and extra info.
    static int numOptions;
    static int pROAD_LENGTH;
    static int pROAD_CAPACITY;
    static int pMAX_PHASE_DURATION;
    static int pMAX_CYCLE_LENGTH;
    static int pRPC_CYCLE_LENGTH;
    static bool pVERBOSE;
    static bool pGUI;
    static int pSEED;
    static char* pBEST_PARAMS_FILE;
    static char* pPARAM_FILE;
    static char* pRESTORE_FILE;
    static bool pRESTORE;
    static bool pLEARN;
    static double pBIAS;
    static double pDISCOUNT;
    static double pSTEP_SIZE;
    static int pSTEPS_PER_EPOCH;
    static int pMAX_STEPS;
    static int pMAX_TIME;
    static int pHIDDEN;
    static double pMAX_RAND;
    static bool pUSE_CURRENT_PHASE_INFO;
    static bool pUSE_CYCLE_DURATION;
    static bool pUSE_CURRENT_PHASE_DURATION_INFO;
    static bool pUSE_PHASE_DURATION_INFO;
    static bool pUSE_DETEC_ACTIVE_INFO;
    static bool pUSE_DETEC_HISTORY_INFO;
    static bool pUSE_NEIGHBOUR_INFO;
    static bool pUSE_PHASE_HISTORY_INFO;
    static int pCONTROLLER;
    static int pROWS;
    static int pCOLS;
    static int pSCENARIO;
    static int pCARS_PER_TIME_STEP;
    static int pSUDDEN_INFLUX;
    static int pFIXED_PHASE_LENGTH;
    static double pUPPER_THRESHOLD;
    static double pLOWER_THRESHOLD;
    static double pPRE_LEARNING_STEPSIZE;
    static int pPRE_LEARNING_TIME;
    static bool pBOOST_SCATS;
    static bool pLOCAL_REWARDS;
    static bool pQUEUE_LENGTH_REWARDS;
    static bool pBASELINE;
    static int pOFFSET;
    static int pSAVE_INTERSECTION_POLICY;
    static int pSAVE_FROM;
    static int pGUI_SPEED;
    static bool pNAC;
    static double pNAC_DISCOUNT;
    static bool pSCATS_CYCLE_EXTENSION;
    static double pSCATS_GOAL_SATURATION;
    static bool pGREEDY_DRIVERS;
    static int pGUI_DELAY;
    static int pLINE_SEARCH_STEPS;
    static double pTOLERANCE;
    static double pBACK_OFF;
    static double pEXPONENT_BASE;
    static double pDOWNHILL_THRESH;
    static int pMAX_TRIES;
    static double pSTEP_EDGE;
    static double pSTEP_ENODE;
    static int pMAX_TREE_NO;
    static int pMAX_TREE_TIME;
    static double pMAX_RAND_EDGE;
    static int pMAX_DELAY;
    static int pMIN_DELAY;
    static int pEDGE_REWARD_DEF;
    static int pEDGE_FEA_SEL;
    static int pTIME_MOD;
    static int pEXIT_CHECK_WINDOW;
    static int pTHROUGHPUT_REWARDS;
    static double pEXIT_TOLERANCE;


    // Sets the value of an option by name. No type checking.
    // Quite slow. Use the static vals if name known. Note that there is 
    // no support for adding new variables, only changing the vals of
    // existing vars. Note in particular, if changing string val, the
    // previous string should be gotten first, and the memory asscociate
    // with it freed. setValFromString() does this for you.
    // INPUT : name of option
    // INPUT : void* val to set.
    // OUTPUT: true on success, false if no option of that name exists. 
    // OUTPUT: void* pointer to val, or NULL if no option found.
    static bool setVal(char* s, void* val);

    // Set the value of a parameter from the string representation of
    // the value. Takes care of freeing previous string memory if the
    // type is a string. Cannot be used to declare a new variable.
    // INPUT : name of option
    // INPUT : value of option
    // OUTPUT: true on success, false if no option of that name exists. 
    static bool setValFromChar(const char* s, const char* val);

    // Gets the value of an option by name. No type checking.
    // Quite slow. Use the static vals if name known.
    // INPUT : name of option
    // OUTPUT: void* pointer to val, or NULL if no option found.
    static void* getVal(char* s);

    // Generate options help.
    static void help();

    // Dump option values
    static void print(ostream& out);

    // Process command line args that may contain parameters.
    // INPUT: normal argv, argc from command line
    // OUTPUT: Current optind for processing remainder of options
    static int processOpts(int argc, char **argv);

    // Parse a file that contains options
    // INPUT : filename
    // OUTPUT: Number of options read successfully from file
    static int parseOptionsFile(char* fname);

};
// End of auto generated file
