#ifdef HAVE_QT

#include <list>
#include <vector>
#include <iostream>
#include <time.h>

#include <qapplication.h>
#include <qwidget.h>
#include <qthread.h>

#include "PGBasics.hh"
#include "definitions.hh"
#include "Ps.hh"
#include "intersection.hh"
#include "car.hh"
#include "sts.hh"
#include "OLPomdp.hh"
#include "GPomdp.hh"
#include "LineSearchAlg.hh"
#include "STSOptim.hh"

#include "simgui.hh"
#include "testgui.hh"

using namespace libpg;

TestGui::TestGui(STSOptim& stso, WidgetTest* w)  :  
  learner(stso) {
  widget = w;
    simulator = learner.get_simulator(); 
}

void TestGui::run() {
  //cout << "in run()" << endl; 
  int steps = 0;
  learner.stepsPerEpoch = 1;
  learner.printPerformanceInfo(true, -1, 0, 0, 0); // prints just titles (-1 to avoid reset)
	     
  while(true) {
  //simulator->run();
    Vector reward_vec(simulator->getRewardDim());
    //Vector statistics(simulator->getStatisticsNames().size());
    double avg_reward = 0;
    if(Ps::pLEARN) {
      avg_reward = learner.doSteps(reward_vec, 1, true);
    }
    else {
      avg_reward = learner.evaluate(reward_vec, 1);
    }
    steps += 1;
    //cout<<"Trial: " <<steps<<"\t"<<avg_reward<<"\t0\n";
    learner.printPerformanceInfo(false, steps, avg_reward, 
				   learner.get_controller()->getMaxParam() , 
				   0);
    widget->update();
    usleep(Ps::pGUI_SPEED);
  }
} 

#endif
