#ifndef CRFExact_hh
#define CRFExact_hh


namespace tree_mcmc {


class CRFExact : public CRFBasic {


protected:

	/** 
	 *	For CRF which is originally a tree, then work on this tree
	 */
	void build_ori_tree(int root_id = -1);

	virtual void init_graph(int *argc, char **argv) = 0;

public:

	CRFExact(int *argc, char** argv);

	// A generic sampler initializer
	virtual void init_tree_sampler(int *argc, char **argv);

	/**
	 *	Perform inference on the whole graph (tree) using RB
	 */
	virtual void infer_graph();


	/**
	 *	Perform sampling on the whole graph (tree) using RB
	 */
	virtual void sample_graph();

};

}

#endif
