#include "TreeBasics.hh"

using namespace std;

namespace tree_mcmc {

// Note, those which will be printed once are controlled by verbosity
// Those that display in inner loop are controlled by MY_DEBUG
// Under MY_DEBUG, verbosity still controls verbosity level
// #define MY_DEBUG

// Whether to use RB estimator for multiple times, or only once



// int topo_id;
int fea_id;


// int num_row;				// number of rows, only for grid
// int num_col;				// number of columns, only for grid
// int num_cross_upper;		// how many nodes are there above the horizontal chain?
// int cross_hori_id;			// cross at which horizontal node?


int count_act1, count_act2;
double node_step_size;
bool exit_flag;

int *current_phase;



// bool use_local_reward;
// int max_delay;
// int min_delay;
// int **history_action;

// int edge_reward_def;


// int get_edge_id(int node1, int node2)
// {
// 	if (topo_id == 1)					// Chain
// 	{
// 		return node1 < node2 ? node1 : node2;
// 	}
// 	else if (topo_id == 2)				// Grid
// 	{
// 		static int offset = global_num_node - num_row;
// 
// 		if(node1 < node2)
// 		{
// 			if (node1 + 1 == node2)		// horizontal edge
// 				return node1 - int(node1 / (double)num_col);
// 			else						// vertical edge
// 				return offset + node1;
// 		}
// 		else
// 		{
// 			if (node2 + 1 == node1)		// horizontal edge
// 				return node2 - int(node2 / (double)num_col);
// 			else						// vertical edge
// 				return offset + node2;
// 		}	
// 	}
// 	else if (topo_id == 3)				// Circle
// 	{
// 		if(node1 < node2)
// 		{
// 			if (node1 + 1 == node2)		// horizontal edge
// 			{
// 				if (node1 < num_col)
// 					return node1;
// 				else
// 					return node1 - 1;
// 			}
// 			else						// vertical edge
// 			{
// 				if (node1 == 1)
// 					return global_num_node - 1;
// 				else
// 					return global_num_node;
// 			}
// 		}
// 		else
// 		{
// 			if (node2 + 1 == node1)		// horizontal edge
// 			{
// 				if (node2 < num_col)
// 					return node2;
// 				else
// 					return node2 - 1;
// 			}
// 			else						// vertical edge
// 			{
// 				if (node2 == 1)
// 					return global_num_node - 1;
// 				else
// 					return global_num_node;
// 			}
// 		}
// 	}
// 	else if (topo_id == 4)				// Cross
// 	{
// 		if (node1 > node2)
// 		{
// 			if (node2 <= num_cross_upper)
// 				return node2 + num_col - 1;	
// 			else if (node1 <= num_col + num_cross_upper)
// 				return node2 - num_cross_upper;
// 			return node1 - 1;
// 		}
// 		else
// 		{
// 			if (node1 <= num_cross_upper)
// 				return node1 + num_col - 1;	
// 			else if (node2 <= num_col + num_cross_upper)
// 				return node1 - num_cross_upper;
// 			return node2 - 1;
// 		}
// 	}
// 	else
// 	{
// 		cout<<"In get_edge_id, unforseen topo_id "<<topo_id<<".  Abort.\n";
// 		exit(1);
// 	}
// }


/* All below are generic, not only for grid  */

/**
 *	Find a tree for initial sampling, result stored in init_tree
 *	Note: Construction of this tree requires discarding edges. 
 *	Only needs the adjacency matrix.
 */
// void build_init_tree(int root_id)
// {
// 	int cur_tail_index, cur_head_index, cur_head_node, cur_edge;
// 	int *visited, *buf, i, fan_out, root;
// 	
// 	init_tree = new Tree;
// 	init_tree->num_node = global_num_node;
// 	init_tree->num_son = new int [global_num_node + 1];
// 	init_tree->local_to_global = new int [global_num_node + 1];
// 	init_tree->send = new Node * [global_num_node];
// 	init_tree->rec = new Node * [global_num_node];
// 	init_tree->order_id = new int [global_num_node];
// 	init_tree->tree_edge = new Edge * [global_num_node];
// 	init_tree->cond_edge_index = new int [global_num_node + 2];
// 	init_tree->cond_edge_array = NULL;
// 	
// 	visited = new int [global_num_node + 1];
// 	buf = new int [global_num_node + 1];
// 	cur_tail_index = 2;	
// 	cur_edge = 1;
// 	
// 	for(i = 1; i <= global_num_node; i++)
// 	{
// 		visited[i] = 0;
// 		init_tree->local_to_global[i] = i;
// 	}
// 
// 		
// 	// First, randomly choose a root
// 	if (root_id < 0)
// 		root = int(ceil((rand() + 1) / ((double) RAND_MAX + 1 )* global_num_node) + 0.5);
// 	else
// 		root = root_id;
// 	buf[1] = root;
// 	visited[root] = 1;
// 	
// 	// Second from root, expand out	
// 	for (cur_head_index = 1; cur_head_index <= global_num_node && cur_head_index < cur_tail_index; cur_head_index ++)
// 	{
// 		cur_head_node = buf[cur_head_index];
// 		fan_out = 1;
// 		for (i = 1; i <= global_num_node; i ++)
// 		{
// 			if (adj_matrix[cur_head_node][i] && !visited[i])	 // there is an edge linking to an unvisited node
// 			{
// 				visited[i] = 1;
// 				init_tree->send[cur_edge] = node_array + cur_head_node;
// 				init_tree->rec[cur_edge] = node_array + i;
// 
// 				init_tree->tree_edge[cur_edge] = edge_array + get_edge_id(cur_head_node, i);
// 
// 				init_tree->order_id[cur_edge] = fan_out++;
// 				buf[cur_tail_index] = i;
// 				cur_edge ++;	cur_tail_index ++;
// 			}
// 		}
// 
// 		init_tree->num_son[cur_head_node] = --fan_out;
// 		node_array[cur_head_node].max_num_son = fan_out;
// 	}
// 	
// 	// Now check whether the graph is connected. We assume it is connected.
// 	if(cur_head_index <= global_num_node)
// 	{
// 		printf("The input graph given by the adjacency matrix is not connected.  Exit.\n");
// 		exit(1);
// 	}
// 
// 	for (cur_head_index = 1; cur_head_index <= global_num_node + 1; cur_head_index ++)
// 		init_tree->cond_edge_index[cur_head_index] = 1;
// 	
// 	delete []visited;
// 	delete []buf;
// }


// Calculate the send, rec ... for the trees
// Similar to build_init_tree(), but different
// Note: Construction of this tree requires NO discarding of edges. 
// void build_tree(Tree *cur_tree, int root_id)
// {
// 	int *visited, *global_buf, i, fan_out, global_root, local_num_node, local_next;
// 	int cur_tail_index, cur_head_index, cur_edge, global_cur_head_node;
// 	int *edge_assign, *count_cond_edge;
// 	Node *p_node;
// 
// 	// cur_tree->num_node is already there
// 	local_num_node = cur_tree->num_node;
// 	cur_tree->num_son = new int [local_num_node + 1];
// 	cur_tree->send = new Node* [local_num_node];
// 	cur_tree->rec = new Node* [local_num_node];
// 	cur_tree->order_id = new int [local_num_node];
// 	cur_tree->tree_edge = new Edge* [local_num_node];
// 	cur_tree->cal_edge_rb = new bool [local_num_node];
// 	
// 	cur_tree->cond_edge_index = new int [local_num_node + 2];	
// 	
// 	visited = new int [global_num_node + 1];
// 	global_buf = new int [local_num_node + 1];
// 	edge_assign = new int [global_num_edge + 1];
// 	count_cond_edge = new int [global_num_node + 1];
// 	
// 	cur_tail_index = 2;
// 	cur_head_index = 1;
// 	cur_edge = 1;
// 	
// 	for(i = 1; i <= global_num_node; i++)
// 	{
// 		visited[i] = -1;		
// 		count_cond_edge[i] = -1;
// 	}
// 
// 	for(i = 1; i <= global_num_edge; i++)
// 		edge_assign[i] = 0;
// 
// 	// first, randomly choose a root
// 	if (root_id < 0)
// 		global_root = cur_tree->local_to_global[int(ceil((rand() + 1) / ((double) RAND_MAX + 1) * local_num_node ) + 0.5)];
// 	else
// 		global_root = root_id;
// 
// 	global_buf[1] = global_root;
// 	
// 	// second from root, expand out	
// 	for(cur_head_index = 1; cur_head_index <= local_num_node && cur_head_index < cur_tail_index; cur_head_index ++)
// 	{
// 		global_cur_head_node = global_buf[cur_head_index];
// 		count_cond_edge[global_cur_head_node] = 0;
// 
// 		fan_out = 1;
// 		for(local_next = 1; local_next <= local_num_node &&
// 								!adj_matrix[global_cur_head_node][cur_tree->local_to_global[local_next]]; local_next++) ;
// 
// 		// traverse all the nodes in the whole graph
// 		for(i = 1; i <= global_num_node; i ++)
// 		{
// 			// if there is a link between i and global_cur_head_node
// 			if (adj_matrix[global_cur_head_node][i])
// 			{
// 				// if i is in the same tree
// 				if (local_next <= local_num_node && i == cur_tree->local_to_global[local_next])
// 				{
// 					if (visited[i] >= 0)		// already visited this node on this tree
// 					{
// 						if (adj_matrix[i][global_cur_head_node] < 0)		// traced to father node, that is ok
// 						{
// 							adj_matrix[i][global_cur_head_node] = 1;
// 							for(local_next++; local_next <= local_num_node &&
// 								!adj_matrix[global_cur_head_node][cur_tree->local_to_global[local_next]]; local_next++) ;
// 						}
// 						else			// if not father node, but still already visited, then it is not a tree (there is loop)
// 						{
// 							printf("Error, the tree is not a natural tree.  Exit.\n");
// 							display_tree(cur_tree, 1);
// 							exit(1);
// 						}
// 					}
// 					else
// 					{
// 						visited[i] = 1;
// 						adj_matrix[global_cur_head_node][i] = -1;
// 						cur_tree->send[cur_edge] = node_array + global_cur_head_node;
// 						cur_tree->rec[cur_edge] = node_array + i;
// 						cur_tree->tree_edge[cur_edge] = edge_array + get_edge_id(global_cur_head_node, i);
// 
// 						cur_tree->order_id[cur_edge] = fan_out;
// 						global_buf[cur_tail_index] = i;
// 						cur_edge ++;			fan_out ++;			cur_tail_index++;
// 
// 						// glide to the next neighbor of global_cur_head_node in current tree
// 						// local_to_global must be in increasing order
// 						for(local_next++; local_next <= local_num_node &&
// 								!adj_matrix[global_cur_head_node][cur_tree->local_to_global[local_next]]; local_next++) ;
// 					}
// 				} 
// 				else	// if i is in a different tree, then this edge is conditioned on
// 				{
// 					edge_assign[get_edge_id(global_cur_head_node, i)] = global_cur_head_node;	
// 					count_cond_edge[global_cur_head_node] ++;
// 				}
// 			}
// 		}
// 
// 		// borrow the visited array to store the fan_out (number of son)
// 		visited[global_cur_head_node] = fan_out - 1;
// 	}
// 
// 	// record the cur_tree->num_son and node_arrary.max_num_son, allocate the sample_buf space
// 	cur_edge = -1;		// borrow the cur_edge for max_num_class
// 	for (i = 1; i <= local_num_node; i++) 
// 	{		
// 		global_cur_head_node = cur_tree->local_to_global[i];
// 		cur_tree->num_son[i] = visited[global_cur_head_node];
// 		p_node = node_array +global_cur_head_node;
// 
// 		if(p_node->max_num_son < cur_tree->num_son[i])
// 			p_node->max_num_son = cur_tree->num_son[i];
// 
// 		if (p_node->num_class > cur_edge)
// 			cur_edge = p_node->num_class;
// 
// 		if (cur_tree->num_son[i] < 0)
// 		{
// 			printf("The tree is not connected.  Node %d is not visited.\n", cur_tree->local_to_global[i]);
// 			display_tree(cur_tree, 1);
// 			exit(1);
// 		}
// 	}
// 
// 	// now count how many conditional edges each tree node has
// 	cur_edge = 1;
// 	for (i = 1; i <= local_num_node; i ++)
// 	{
// 		visited[cur_tree->local_to_global[i]] = i;	// now visited[] is the inverse map of local_to_global
// 		cur_tree->cond_edge_index[i] = cur_edge;
// 		cur_edge += count_cond_edge[cur_tree->local_to_global[i]];
// 	}
// 
// 	cur_tree->cond_edge_index[local_num_node + 1] = cur_edge;
// 
// 	cur_tree->cond_edge_array = new Edge * [cur_edge];
// 
// 	// now fill up the cond_edge_array[] and cond_edge_orient[]
// 	for (i = 1; i <= global_num_edge; i++)
// 	{
// 		global_cur_head_node = edge_assign[i];	// get the tree node (global)
// 		if (global_cur_head_node)		// if this edge is conditioned on
// 		{
// 			// now assign edge i to local node count_cond_edge[edge_assign[i]]
// 			cur_head_index = cur_tree->cond_edge_index[visited[global_cur_head_node]] 
// 								+ (--count_cond_edge[global_cur_head_node]);
// 			cur_tree->cond_edge_array[cur_head_index] = edge_array + i;
// 		}
// 	}
// 
// 	delete [] visited;
// 	delete [] global_buf;
// 	delete [] edge_assign;
// 	delete [] count_cond_edge;
// }


// For CRF which is originally a tree
// void build_ori_tree(int root_id)
// {
// 	int cur_node, i, max_num_class;
// 	Node * p_node;
// 
// 	// First allocate and define tree
// 	init_tree = new Tree;
// 	init_tree->cal_node_rb = true;
// 
// 	init_tree->num_node = global_num_node;
// 	init_tree->local_to_global = new int[global_num_node + 1];
// 
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node++)
// 		init_tree->local_to_global[cur_node] = cur_node;
// 
// 	build_tree(init_tree, root_id);
// 
// 	for (cur_node = 1; cur_node <= global_num_edge; cur_node ++)
// 		init_tree->cal_edge_rb[cur_node] = true;
// 
// 	if(verbosity & 1)
// 	{
// 		printf("********     Chain     ********\n");
// 		display_tree(init_tree, 7);		
// 	}
// 
// 	// Finally allocate the msg_buffer for all nodes after obtaining the max_num_son information
// 
// 	p_node = node_array + 1;
// 	max_num_class = 0;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		if (p_node->num_class > max_num_class)
// 			max_num_class = p_node->num_class;
// 		p_node->msg_buffer = new double * [p_node->max_num_son + 1];
// 		for (i = 1; i <= p_node->max_num_son; i++)
// 			p_node->msg_buffer[i] = new double [p_node->num_class + 1];
// 		p_node ++;
// 	}
// 	
// 
// 	sample_buf = new double [max_num_class + 1];
// 	rb_buf = new double * [max_num_class + 1];
// 	for (cur_node = 1; cur_node <= max_num_class; cur_node ++)
// 		rb_buf[cur_node] = new double [max_num_class + 1];
// 
// 	for (cur_node = 1; cur_node <= init_tree->num_node; cur_node ++)
// 		node_array[cur_node].num_son = init_tree->num_son[cur_node];
// }


// Calculate the send, rec ... for all the trees in all the partitions
// This is generic, once the trees and partitions are defined.
// Let's skip the level of build_partition
// void build_all_trees()
// {
// 	int i, j, k, cur_node, max_num_class, cur_edge;
// 	bool *edge_covered;
// 	Partition *part;
// 	Tree *p_tree;
// 	Node *p_node;
// 
// 	build_init_tree();
// 	if (verbosity & 1)
// 		display_tree(init_tree, 1);
// 
// 	edge_covered = new bool [global_num_edge + 1];
// 	for (i = 1; i <= global_num_edge; i ++)
// 		edge_covered[i] = false;
// 
// 	for (i = 1; i <= global_num_partition; i ++)
// 	{
// 		if (verbosity & 1)
// 			printf("********   Partition %d    ********\n", i);
// 
// 		part = partitions + i;
// 		for (j = 1; j <= part->num_trees; j ++)
// 		{
// 			p_tree = part->trees + j;
// 			build_tree(p_tree);
// 
// 			for (k = 1; k < p_tree->num_node; k ++)
// 			{
// #ifdef RB_EDGE_SINGLE
// 				cur_edge = p_tree->tree_edge[k] - edge_array;
// 				if (!edge_covered[cur_edge])
// 				{
// 					edge_covered[cur_edge] = true;
// 					p_tree->cal_edge_rb[k] = true;					
// 				}
// 				else
// 					p_tree->cal_edge_rb[k] = false;
// #else
// 				p_tree->cal_edge_rb[k] = true;
// #endif
// 			}
// 			if(verbosity & 1)
// 			{
// 				printf("********   Tree %d    of   Partition %d   ********\n", j, i);
// 				display_tree(part->trees + j, 1);
// 			}
// 		}
// 	}
// 
// 	// Finally allocate the msg_buffer for all nodes after obtaining the max_num_son information
// 	max_num_class = 0;
// 	p_node = node_array + 1;
// 
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		if (p_node->num_class > max_num_class)
// 			max_num_class = p_node->num_class;
// 		p_node->msg_buffer = new double * [p_node->max_num_son + 1];
// 		for (i = 1; i <= p_node->max_num_son; i++)
// 			p_node->msg_buffer[i] = new double [p_node->num_class + 1];
// 
// 		p_node ++;
// 	}
// 	
// 	sample_buf = new double [max_num_class + 1];
// 	rb_buf = new double * [max_num_class + 1];
// 	for (cur_node = 1; cur_node <= max_num_class; cur_node ++)
// 		rb_buf[cur_node] = new double [max_num_class + 1];
// 
// 	delete [] edge_covered;
// }


// clear the RB estimations
// void clear_RB()
// {
// 	int cur_node, cur_edge, cur_class_1, cur_class_2;
// 	double *p1, **p2;
// 	Node *p_node;
// 	Edge *p_edge;
// 
// 	p_node = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		p1 = p_node->rb_est + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_node->num_class; cur_class_1 ++)		
// 			*(p1 ++) = 0.0;
// 
// 		p_node ++;
// 	}
// 
// 	p_edge = edge_array + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		p2 = p_edge->rb_est + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_edge->p_node[1]->num_class; cur_class_1 ++)
// 		{
// 			p1 = *(p2 ++) + 1;
// 			for (cur_class_2 = 1; cur_class_2 <= p_edge->p_node[2]->num_class; cur_class_2 ++)
// 				*(p1 ++) = 0.0;
// 		}
// 		p_edge ++;
// 	}
// }


// Normalize the RB estimations
// void normalize_RB()
// {
// 	// Finally, calculate the node and edge feature expectations
// 	int cur_node, cur_edge, cur_class_1, cur_class_2;
// 	double *rb1, **rb2, sum;
// 	Node *p_node;
// 	Edge *p_edge;
// 
// 	p_node = node_array + 1;
// 	
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		// First, normalize the node RB estimates
// 		sum = 0.0;
// 		rb1 = p_node->rb_est + 1;
// 
// 		for (cur_class_1 = 1; cur_class_1 <= p_node->num_class; cur_class_1 ++)
// 			sum += *(rb1 ++);
// 		rb1 = p_node->rb_est + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_node->num_class; cur_class_1 ++)
// 			*(rb1 ++) /= sum;
// 
// 		p_node ++;
// 	}
// 
// 	p_edge = edge_array + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		// First, normalize the edge RB estimates
// 		sum = 0.0;
// 		rb2 = p_edge->rb_est + 1;
// 
// 		for (cur_class_1 = 1; cur_class_1 <= p_edge->p_node[1]->num_class; cur_class_1 ++)
// 		{
// 			rb1 = *(rb2 ++) + 1;
// 
// 			for (cur_class_2 = 1; cur_class_2 <= p_edge->p_node[2]->num_class; cur_class_2 ++)
// 				sum += *(rb1 ++);
// 		}
// 
// 		rb2 = p_edge->rb_est + 1;
// 
// 		for (cur_class_1 = 1; cur_class_1 <= p_edge->p_node[1]->num_class; cur_class_1 ++)
// 		{
// 			rb1 = *(rb2 ++) + 1;
// 
// 			for (cur_class_2 = 1; cur_class_2 <= p_edge->p_node[2]->num_class; cur_class_2 ++)
// 				*(rb1 ++) /= sum;
// 		}
// 		
// 		p_edge ++;
// 	}
// }

// If you DO want RB, then use infer_distribution
// Use sample_distribution iff you do NOT need RB.
// Sample from exp(log_prob[]), which has num_class elements
// Just sample, NO calculation of the RB estimation and store in sample_buf[]
// It Subtracts the maximum element.
// int sample_distribution(double *log_prob, int num_class)
// {
// 	int cur_class;
// 	double *p_pot_1, *p_pot_2, sample;
// 
// 	sample = 0.0;
// 	p_pot_1 = log_prob + 1;
// 	p_pot_2 = sample_buf + 1;
// 
// 	for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 	{
// 		*p_pot_2 = fexp2r_check( *(p_pot_1 ++) );
// 		sample += * (p_pot_2 ++);
// 	}
// 
// 	// If no need of RB estimation, then one can avoid divisions
// 	while(1)
// 	{
// 		sample *= (rand() + 1) / ((double) RAND_MAX + 1);
// 		p_pot_2 = sample_buf + 1;
// 		for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 		{
// 			if (sample <= *p_pot_2)
// 				return cur_class;
// 			sample -= *(p_pot_2 ++);
// 		}
// 	}
// 
// 	return -1;
// }


// If you do NOT want RB, then use sample_distribution
// Use infer_distribution iff you need RB.
// Sample from exp(log_prob[]), which has num_class elements
// Also calculate the RB estimation and store in !!!sample_buf[]!!!
// It does NOT subtract the maximum element.
// int infer_distribution(double *log_prob, int num_class)
// {
// 	int cur_class;
// 	double *p_pot_1, *p_pot_2, sample;
// 
// 	sample = 0.0;
// 
// 	p_pot_1 = log_prob + 1;
// 	p_pot_2 = sample_buf + 1;
// 	for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 	{
// 		*p_pot_2 = fexp2r_check( *(p_pot_1 ++) );
// 		sample += * (p_pot_2 ++);
// 	}
// 
// 	p_pot_2 = sample_buf + 1;
// 	for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 	{
// 		*p_pot_2 /= sample;
// 		p_pot_2 ++;
// 	}
// 
// 	while (1)
// 	{
// 		sample = (rand() + 1) / ((double) RAND_MAX + 2);
// 
// 		p_pot_2 = sample_buf + 1;
// 		for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 		{
// 			if (sample <= *p_pot_2)
// 				return cur_class;
// 			sample -= *(p_pot_2 ++);
// 		}
// 	}
// 
// 	return -1;
// }


// Calculate the conditional potentials of cur_tree
// void cal_cond_pot(Tree *cur_tree)
// {
// 	int cur_node, cur_edge, cur_class, orient;
// 	double *p_pot, *p_start, *p_cur;
// 	Node *p_node;
// 	Edge *p_edge;
// 
// 	// loop over all nodes in the tree
// 	for (cur_node = 1; cur_node <= cur_tree->num_node; cur_node ++)
// 	{
// 		p_node = node_array + cur_tree->local_to_global[cur_node];		// current node
// 
// 		p_cur = p_start = p_node->cond_pot + 1;
// 		p_pot = p_node->node_pot + 1;
// 
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 			*(p_cur++) = *(p_pot++);
// 
// 		for (cur_edge = cur_tree->cond_edge_index[cur_node]; cur_edge < cur_tree->cond_edge_index[cur_node + 1]; cur_edge ++)			
// 		{
// 			p_cur = p_start;		// current node's conditional potential buffer pointer
// 			p_edge = cur_tree->cond_edge_array[cur_edge];		// current node's neighbor on conditional edge
// 			orient = 2 - (p_node == p_edge->p_node[2]);
// 
// 			p_pot = p_edge->edge_pot[orient][p_edge->p_node[orient]->sampled_value] + 1;
// 
// 			for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 				*(p_cur++) += *(p_pot++);
// 		}
// 	}
// }


// Perform forward message passing (from leaves to root)
// void forward_msg_pass(Tree *cur_tree)
// {
// 	int cur_edge, cur_class_1, cur_class_2, cur_son, edge_orient;
// 	double sum, *p_pot_1, *p_pot_2, max_msg_1, max_msg_2, **pep2, *pep1;
// 	Edge *p_edge, **p_edge2;
// 	Node *p_send, *p_rec;
// 
// 	p_edge2 = cur_tree->tree_edge + cur_tree->num_node - 1;
// 	for (cur_edge = cur_tree->num_node - 1; cur_edge >= 1; cur_edge --)
// 	{
// 		p_edge = *(p_edge2 --);
// 
// 		// For forward msg passing, sender and receiver are inversed
// 		p_send = cur_tree->rec[cur_edge];
// 		p_rec = cur_tree->send[cur_edge];
// 
// 		edge_orient = 2 - (p_send > p_rec);		// 1: large -> small, 2: small -> large
// 
// 		// First, sender should fill up its sum-up row (summing up its messages)
// 		p_pot_1 = p_send->sum_msg + 1;
// 		p_pot_2 = p_send->cond_pot + 1;
// 
// 		// Assign conditional potentials to sum_msg as initialization
// 		for (cur_class_1 = 1; cur_class_1 <= p_send->num_class; cur_class_1 ++)		
// 			*(p_pot_1 ++) = *(p_pot_2 ++);
// 
// 		// Add up all the messages into sum_msg
// 		for (cur_son = 1; cur_son <= p_send->num_son; cur_son ++)
// 		{
// 			p_pot_1 = p_send->sum_msg + 1;
// 			p_pot_2 = p_send->msg_buffer[cur_son] + 1;
// 
// 			for (cur_class_1 = 1; cur_class_1 <= p_send->num_class; cur_class_1 ++)
// 				*(p_pot_1++) += *(p_pot_2++);
// 		}
// 
// 		// Find the maximum exponent
// 		max_msg_1 = NINFINITY;			// maximum exponent of double number (base 2)
// 		p_pot_1 = p_send->sum_msg + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_send->num_class; cur_class_1 ++)
// 		{
// 			if (*p_pot_1 > max_msg_1)
// 				max_msg_1 = *p_pot_1;
// 			p_pot_1 ++;
// 		}
// 
// 		// Subtract the maximum exponent
// 		p_pot_1 = p_send->sum_msg + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_send->num_class; cur_class_1 ++)
// 			*(p_pot_1 ++) -= max_msg_1;
// 
// 		// Receiver just puts the message into its message buffer
// 		// No intermediate data structure for message
// 
// 		max_msg_2 = NINFINITY;
// 		p_pot_2 = p_rec->msg_buffer[cur_tree->order_id[cur_edge]] + 1;
// 		pep2 = p_edge->edge_pot[edge_orient] + 1;
// 
// 		// Loop for all classes of receiver
// 		for (cur_class_2 = 1; cur_class_2 <= p_rec->num_class; cur_class_2 ++)
// 		{
// 			sum = 0.0;
// 			p_pot_1 = p_send->sum_msg + 1;
// 			pep1 = *pep2 + 1;
// 
// 			// Compute the message
// 			for (cur_class_1 = 1; cur_class_1 <= p_send->num_class; cur_class_1 ++)
// 				sum += fexp2r_check( *(p_pot_1 ++) + *(pep1++) );
// 
// 			*p_pot_2 = flog2r(sum);
// 
// 			// Record the largest message element
// 			if (*p_pot_2 > max_msg_2)
// 				max_msg_2 = *p_pot_2;
// 
// 			p_pot_1 ++;		pep2 ++;		p_pot_2 ++;
// 		}
// 
// 		// Subtract the largest message element
// 		p_pot_2 = p_rec->msg_buffer[cur_tree->order_id[cur_edge]] + 1;
// 		for (cur_class_2 = 1; cur_class_2 <= p_rec->num_class; cur_class_2 ++)
// 			*(p_pot_2 ++) -= max_msg_2;
// #ifdef MY_DEBUG
// 		printf("Message %d -> %d:\t", p_send - node_array, p_rec - node_array);
// 		p_pot_2 = p_rec->msg_buffer[cur_tree->order_id[cur_edge]] + 1;
// 		for (cur_class_2 = 1; cur_class_2 <= p_rec->num_class; cur_class_2 ++)
// 			printf("%g\t", *(p_pot_2 ++));
// 		printf("\n");
// #endif
// 	}
// }


// Get a sample of the root, run between forward and backward msg prop
// void infer_root(Tree *cur_tree)
// {
// 	int cur_class, cur_son;
// 	double *p_pot_1, *p_pot_2, max_pot;
// 	Node *p_node;
// 
// 	p_node = cur_tree->send[1];
// 
// 	// First, root should fill up its sum-up row (summing up its messages)
// 
// 	// Assign conditional potentials to sum_msg
// 	p_pot_1 = p_node->sum_msg + 1;
// 	p_pot_2 = p_node->cond_pot + 1;
// 	for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		*(p_pot_1 ++) = *(p_pot_2 ++);
// 
// 	// Assign conditional potentials to sum_msg
// 	for (cur_son = 1; cur_son <= p_node->num_son; cur_son ++)
// 	{
// 		p_pot_1 = p_node->sum_msg + 1;
// 		p_pot_2 = p_node->msg_buffer[cur_son] + 1;
// 
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 			*(p_pot_1++) += *(p_pot_2++);
// 	}
// 
// 	max_pot = NINFINITY;
// 	p_pot_1 = p_node->sum_msg + 1;
// 	for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 	{
// 		if(*p_pot_1 > max_pot)
// 			max_pot = *p_pot_1;
// 		p_pot_1 ++;
// 	}
// 
// 	p_pot_1 = p_node->sum_msg + 1;
// 	for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		*(p_pot_1 ++) -= max_pot;
// 
// 	// Sample the root node
// 	// p_node->sum_msg will NOT be changed inside
// 	p_node->sampled_value = infer_distribution(p_node->sum_msg, p_node->num_class);
// 
// 	// Fill up the RB estimation
// 	p_pot_1 = p_node->rb_est + 1;
// 	p_pot_2 = sample_buf + 1;
// 	for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		*(p_pot_1 ++) += *(p_pot_2 ++);
// }


// void sample_root(Tree *cur_tree)
// {
// 	int cur_class, cur_son;
// 	double *p_pot_1, *p_pot_2, max_pot;
// 	Node *p_node;
// 
// 	p_node = cur_tree->send[1];
// 
// 	// First, root should fill up its sum-up row (summing up its messages)
// 
// 	// Assign conditional potentials to sum_msg
// 	p_pot_1 = p_node->sum_msg + 1;
// 	p_pot_2 = p_node->cond_pot + 1;
// 	for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		*(p_pot_1 ++) = *(p_pot_2 ++);
// 
// 	// Multiply all the messages that the root has received
// 	for (cur_son = 1; cur_son <= p_node->num_son; cur_son ++)
// 	{
// 		p_pot_1 = p_node->sum_msg + 1;
// 		p_pot_2 = p_node->msg_buffer[cur_son] + 1;
// 
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 			*(p_pot_1++) += *(p_pot_2++);
// 	}
// 
// 	// Find the maximum exponent and subtract
// 	max_pot = NINFINITY;
// 	p_pot_1 = p_node->sum_msg + 1;
// 	for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 	{
// 		if (*p_pot_1 > max_pot)
// 			max_pot = *p_pot_1;
// 		p_pot_1 ++;
// 	}
// 
// 	p_pot_1 = p_node->sum_msg + 1;
// 	for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)			
// 		*(p_pot_1 ++) -= max_pot;
// 
// #ifdef MY_DEBUG
// 		printf("Node %d marginal pot:\t", p_node - node_array);
// 		p_pot_1 = p_node->sum_msg + 1;
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 			printf("%g\t", *(p_pot_1 ++));
// 		printf("\n");
// #endif
// 
// 	// Sample the root node
// 	// p_node->sum_msg will NOT be changed inside
// 	p_node->sampled_value = sample_distribution(p_node->sum_msg, p_node->num_class);
// }


// Calculate the RB estimation of edges.
// No need to take care of subtracting the maximum element of any ORIGINAL data structure
// orient:  1 if large -> small; 2 if small -> large
// void fill_edge_rb(Edge *p_edge, Node *p_send, Node *p_rec, int order_id, int orient)
// {
// 	double *p_pot_1, *p_pot_2, *p_pot_3, *p_small, *p_large, **p_pot2_1, **p_pot2_2, max_pot, sum_exp;
// 	int cur_class_1, cur_class_2, num_class_1, num_class_2;
// 
// 	// Store sender->sum_msg[] - msg_from_receiver in sample_buf[]
// 	p_pot_1 = sample_buf + 1;
// 	p_pot_2 = p_send->sum_msg + 1;
// 	p_pot_3 = p_send->msg_buffer[order_id] + 1;
// 	for (cur_class_1 = 1; cur_class_1 <= p_send->num_class; cur_class_1 ++)
// 		*(p_pot_1 ++) = *(p_pot_2 ++) - *(p_pot_3 ++);
// 
// 	if (orient == 1)	// if edge is from en1 -> en2
// 	{
// 		p_small = p_rec->sum_msg + 1;			// sum_msg of End_node 1 of current edge
// 		p_large = sample_buf + 1;				// sum_msg of End_node 2 of current edge
// 	}
// 	else				// if edge is from en2 -> en1
// 	{
// 		p_small = sample_buf + 1;				// sum_msg of End_node 1 of current edge
// 		p_large = p_rec->sum_msg + 1;			// sum_msg of End_node 2 of current edge
// 	}
// 
// 	num_class_1 = p_edge->p_node[1]->num_class;
// 	num_class_2 = p_edge->p_node[2]->num_class;
// 	p_pot2_1 = p_edge->edge_pot[1] + 1;			// 1: the edge potential
// 	p_pot2_2 = rb_buf + 1;						// 2: RB estimation buffer
// 	max_pot = NINFINITY;
// 
// #ifdef MY_DEBUG
// 	printf("Edge RB estimation %d -> %d:\n", p_send - node_array, p_rec - node_array);
// #endif
// 	for (cur_class_1 = 1; cur_class_1 <= num_class_1; cur_class_1 ++)
// 	{
// 		p_pot_1 = *(p_pot2_1 ++) + 1;			// 1: current edge potential
// 		p_pot_2 = *(p_pot2_2 ++) + 1;			// 2: current RB estimation buffer
// 		p_pot_3 = p_large;						// 3: sum_msg of End_node 2 of current edge
// 
// 		for (cur_class_2 = 1; cur_class_2 <= num_class_2; cur_class_2 ++)
// 		{
// 			// sum_msg(end_node_1) + current_edge_pot + sum_msg(end_node_2)
// 			*p_pot_2 = *p_small + *(p_pot_1 ++) + *(p_pot_3 ++);
// 
// 			if (*p_pot_2 > max_pot)				// record the largest edge potential
// 				max_pot = *p_pot_2;
// #ifdef MY_DEBUG
// 			printf("%g\t", *p_pot_2);
// #endif
// 			p_pot_2 ++;
// 		}
// #ifdef MY_DEBUG
// 			printf("\n");
// #endif
// 		p_small ++;
// 	}
// 
// 	// Subtract the largest edge potential, and exponentiate
// 	sum_exp = 0.0;
// 	p_pot2_2 = rb_buf + 1;
// 	for (cur_class_1 = 1; cur_class_1 <= num_class_1; cur_class_1 ++)
// 	{
// 		p_pot_2 = *(p_pot2_2 ++) + 1;
// 
// 		for (cur_class_2 = 1; cur_class_2 <= num_class_2; cur_class_2 ++)
// 		{
// 			*p_pot_2 = fexp2r_check(*p_pot_2 - max_pot);
// 			sum_exp += *(p_pot_2 ++);
// 		}
// 	}
// 
// 	// Divide by the sum of RB estimator
// 	p_pot2_2 = rb_buf + 1;
// 	p_pot2_1 = p_edge->rb_est + 1;
// 	for (cur_class_1 = 1; cur_class_1 <= num_class_1; cur_class_1 ++)
// 	{			
// 		p_pot_1 = *(p_pot2_1 ++) + 1;
// 		p_pot_2 = *(p_pot2_2 ++) + 1;			
// 
// 		for (cur_class_2 = 1; cur_class_2 <= num_class_2; cur_class_2 ++)
// 			*(p_pot_1++) += *(p_pot_2++) / sum_exp;
// 	}
// }


// Calculate the RB estimation of nodes.
// Potentials are stored in p_node->sum_msg[]
// !!! NOT !!! internally subtract the largest element in p_node->sum_msg[]
// This must be taken care of externally.
// void fill_node_rb(Node *p_node)
// {
// 	int cur_class, num_class;
// 	double sum_pot, *p_pot_1, *p_pot_2;
// 		
// 	// Exponentiate the log potentials
// 	p_pot_1 = p_node->sum_msg + 1;
// 	p_pot_2 = sample_buf + 1;
// 	sum_pot = 0.0;
// 	num_class = p_node->num_class;
// 	for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 	{
// 		*p_pot_2 = fexp2r_check(*(p_pot_1 ++));
// 		sum_pot += *(p_pot_2 ++);
// 	}
// 
// 	// Third, Normalize and add to RB estimation
// 	p_pot_1 = sample_buf + 1;
// 	p_pot_2 = p_node->rb_est + 1;
// 	for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 		*(p_pot_2 ++) += *(p_pot_1 ++) / sum_pot;
// }


// Perform backward message passing, AND sampling (from leaves to root)
// void backward_msg_pass(Tree *cur_tree)
// {
// 	int cur_edge, cur_class_1, cur_class_2, edge_orient;
// 	double *p_pot_1, *p_pot_2, *p_pot_3, **p_pot2_1, *p_pot_3_store, max_pot, sum_pot;
// 	Edge **p_edge2, *p_edge;
// 	Node *p_send, *p_rec;
// 
// 	p_edge2 = cur_tree->tree_edge + 1;
// 	for (cur_edge = 1; cur_edge < cur_tree->num_node; cur_edge ++)
// 	{
// 		p_edge = *(p_edge2 ++);
// 		p_send = cur_tree->send[cur_edge];
// 		p_rec = cur_tree->rec[cur_edge];
// 		edge_orient = 2 - (p_send > p_rec);		// 1 if large -> small; 2 if small -> large
// 
// 		// 1st, sample the receiver
// 		p_pot_1 = *(p_edge->edge_pot[3 - edge_orient] + p_send->sampled_value) + 1;		// edge potential
// 		p_pot_2 = p_rec->sum_msg + 1;		// receiver's sum_msg
// 		p_pot_3 = sample_buf + 1;			// temp buffer
// 		max_pot = NINFINITY;
// 
// 		for (cur_class_1 = 1; cur_class_1 <= p_rec->num_class; cur_class_1 ++)
// 		{
// 			*p_pot_3 = *(p_pot_2 ++) + *(p_pot_1 ++);
// 			if (*p_pot_3 > max_pot)
// 				max_pot = *p_pot_3;
// 			p_pot_3 ++;	
// 		}
// 
// 		// Subtract the maximum exponent
// 		p_pot_3 = sample_buf + 1;			// temp buffer
// 		for (cur_class_1 = 1; cur_class_1 <= p_rec->num_class; cur_class_1 ++)
// 			*(p_pot_3 ++) -= max_pot;
// 
// #ifdef MY_DEBUG
// 		printf("Node %d Dist.:\t", p_rec - node_array);
// 		p_pot_3 = sample_buf + 1;			// temp buffer
// 		for (cur_class_1 = 1; cur_class_1 <= p_rec->num_class; cur_class_1 ++)
// 			printf("%g\t", *(p_pot_3 ++));
// 		printf("\n");
// #endif
// 
// 		p_rec->sampled_value = sample_distribution(sample_buf, p_rec->num_class);
// 
// 		// 2nd, Calculate the edge RB estimation
// 		if (cur_tree->cal_edge_rb[cur_edge])
// 			fill_edge_rb(p_edge, p_send, p_rec, cur_tree->order_id[cur_edge], edge_orient);
// 
// 		// 3rd, Calculate Sender's message and Receiver updates the sum_msg row (add the sender's message)
// 		p_pot_3 = p_rec->sum_msg + 1;						// receiver's sum message
// 		p_pot2_1 = p_edge->edge_pot[edge_orient] + 1;		// edge potentials
// 		p_pot_3_store = p_send->msg_buffer[cur_tree->order_id[cur_edge]] + 1;	// sender's message formerly received from current receiver
// 		max_pot = NINFINITY;
// 
// #ifdef MY_DEBUG
// 		printf("Old node %d potential: ", p_rec - node_array);
// 		for (cur_class_1 = 1; cur_class_1 <= p_rec->num_class; cur_class_1 ++)
// 			printf("%g\t", *(p_pot_3 ++));
// 		p_pot_3 = p_rec->sum_msg + 1;
// 
// 		printf("Message %d -> %d:\t", p_send - node_array, p_rec - node_array);
// #endif
// 
// 		for (cur_class_1 = 1; cur_class_1 <= p_rec->num_class; cur_class_1 ++)
// 		{
// 			p_pot_1 = *(p_pot2_1 ++) + 1;			// edge potentials
// 			p_pot_2 = p_send->sum_msg + 1;			// sender's sum message
// 			p_pot_3_store = p_send->msg_buffer[cur_tree->order_id[cur_edge]] + 1;	// sender's message formerly received from current receiver
// 
// 			sum_pot = 0.0;
// 
// 			for (cur_class_2 = 1; cur_class_2 <= p_send->num_class; cur_class_2 ++)
// 				sum_pot += fexp2r_check( *(p_pot_2 ++) - *(p_pot_3_store ++) + * (p_pot_1 ++) );
// 
// 			*p_pot_3 += flog2r(sum_pot);
// 			if (*p_pot_3 > max_pot)
// 				max_pot = *p_pot_3;
// 
// 			p_pot_3 ++;
// 
// #ifdef MY_DEBUG
// 			printf("%g\t", flog2r(sum_pot));
// #endif
// 		}
// 
// 		p_pot_3 = p_rec->sum_msg + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_rec->num_class; cur_class_1 ++)
// 			*(p_pot_3 ++) -= max_pot;
// 
// 		// 4th, Receiver calculates the node RB estimation
// 		if (cur_tree->cal_node_rb)
// 			fill_node_rb(p_rec);
// 
// #ifdef MY_DEBUG
// 		printf("New node potential: ");
// 		p_pot_3 = p_rec->sum_msg + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_rec->num_class; cur_class_1 ++)
// 			printf("%g\t", *(p_pot_3 ++));
// 		printf("\n");
// #endif
// 	}
// }


// Perform backward sampling, NO backward msg passing (from leaves to root)
// This is much simpler than backward_msg_pass
// void backward_sample(Tree *cur_tree)
// {
// 	int cur_edge, cur_class;
// 	double *p_pot_1, *p_pot_2, *p_pot_3, max_pot;
// 	Edge **p_edge2, *p_edge;
// 	Node *p_send, *p_rec;
// 
// 	p_edge2 = cur_tree->tree_edge + 1;
// 	for (cur_edge = 1; cur_edge < cur_tree->num_node; cur_edge ++)
// 	{
// 		p_edge = *(p_edge2 ++);
// 		p_send = cur_tree->send[cur_edge];
// 		p_rec = cur_tree->rec[cur_edge];
// 
// 		p_pot_1 = *(p_edge->edge_pot[2 - (p_rec > p_send)] + p_send->sampled_value) + 1;
// 		p_pot_2 = p_rec->sum_msg + 1;
// 		p_pot_3 = sample_buf + 1;
// 
// 		max_pot = NINFINITY;
// 		for (cur_class = 1; cur_class <= p_rec->num_class; cur_class ++)
// 		{
// 			*p_pot_3 = *(p_pot_2 ++) + *(p_pot_1 ++);
// 			if (*p_pot_3 > max_pot)
// 				max_pot = *p_pot_3;
// 			p_pot_3 ++;
// 		}
// 
// 		p_pot_3 = sample_buf + 1;
// 		for (cur_class = 1; cur_class <= p_rec->num_class; cur_class ++)
// 			*(p_pot_3 ++) -= max_pot;
// 
// #ifdef MY_DEBUG
// 		printf("Node %d marginal pot:\t", p_rec - node_array);
// 		p_pot_3 = sample_buf + 1;
// 		for (cur_class = 1; cur_class <= p_rec->num_class; cur_class ++)
// 			printf("%g\t", *(p_pot_3 ++));
// 		printf("\n");
// #endif
// 		p_rec->sampled_value = sample_distribution(sample_buf, p_rec->num_class);
// 	}
// }


// Draw a sample of tree
// Almost only used for init_tree
// void sample_tree(Tree *cur_tree)
// {
// #ifdef MY_DEBUG
// 	cout<<"Before cal_cond_pot:"<<endl;
// 	display_tree(cur_tree, 2);
// #endif
// 	
// 	cal_cond_pot(cur_tree);
// #ifdef MY_DEBUG
// 	cout<<"After cal_cond_pot:"<<endl;
// 	display_tree(cur_tree, 2);
// #endif
// 
// 	forward_msg_pass(cur_tree);
// #ifdef MY_DEBUG
// 	cout<<"After forward_msg_pass:"<<endl;
// 	display_tree(cur_tree, 12);
// #endif
// 
// 	sample_root(cur_tree);
// #ifdef MY_DEBUG
// 	cout<<"After infer_root:"<<endl;
// 	cout<<"Root sample: "<<cur_tree->send[1]->sampled_value<<endl;
// 	display_tree(cur_tree, 12);
// #endif
// 
// 	backward_sample(cur_tree);
// #ifdef MY_DEBUG
// 	cout<<"After backward_msg_pass:"<<endl;
// 	display_tree(cur_tree, 12);
// #endif
// }


// Perform inference on the whole grid using RB
// void infer_general()
// {
// 	int cur_part, cur_tree, cur_node, cur_iter = 0, flag_time = 0, t_diff, loop_on;
// 	struct timeb t_start, t_current;
// 	Partition *p_part;
// 	Tree *p_tree;
// 
// 	// First, randomly sample the init_tree	
// 	// For the second partition, directly use the ending samples of the first partition.
// 	for (cur_node = 1; cur_node <= init_tree->num_node; cur_node ++)
// 		node_array[init_tree->local_to_global[cur_node]].num_son = init_tree->num_son[cur_node];
// 	sample_tree(init_tree);
// 
// 	clear_RB();
// 
// 	p_part = partitions + 1;
// 	for (cur_part = 1; cur_part <= global_num_partition; cur_part ++)
// 	{
// 
// #ifdef MY_DEBUG
// 		cout<<"After sample_tree(init_tree):"<<endl;
// 		display_tree(init_tree, 16);
// #endif
// 
// 		p_tree = p_part->trees + 1;
// 		
// 		for (cur_tree = 1; cur_tree <= p_part->num_trees; cur_tree ++)
// 		{
// 			for (cur_node = 1; cur_node <= p_tree->num_node; cur_node ++)
// 				node_array[p_tree->local_to_global[cur_node]].num_son = p_tree->num_son[cur_node];
// 			p_tree ++;
// 		}
// 
// 		if (max_time)
// 		{
// 			flag_time = 1;
// 			ftime(&t_start);
// 		}
// 
// 		loop_on = 1;
// 		for (cur_iter = 1; cur_iter <= max_iter && loop_on; cur_iter ++)
// 		{
// 			p_tree = p_part->trees + 1;
// 			for (cur_tree = 1; cur_tree <= p_part->num_trees; cur_tree ++)
// 			{
// #ifdef MY_DEBUG
// 				cout<<"Before cal_cond_pot:"<<endl;
// 				display_tree(p_tree, 2);
// #endif
// 				cal_cond_pot(p_tree);
// #ifdef MY_DEBUG
// 				cout<<"After cal_cond_pot:"<<endl;
// 				display_tree(p_tree, 2);
// #endif
// 				forward_msg_pass(p_tree);
// 
// #ifdef MY_DEBUG
// 				cout<<"After forward_msg_pass:"<<endl;
// 				display_tree(p_tree, 12);
// #endif
// 				infer_root(p_tree);
// #ifdef MY_DEBUG
// 				cout<<"After infer_root:"<<endl;
// 				display_tree(p_tree, 12);
// #endif
// 				backward_msg_pass(p_tree);
// #ifdef MY_DEBUG
// 				cout<<"After backward_msg_pass:"<<endl;
// 				display_tree(p_tree, 28);
// #endif
// 				if (max_time)
// 				{
// 					if (flag_time == 10)		// check only every 10 iterations
// 					{
// 						flag_time = 1;
// 						ftime(&t_current);
// 
// 						t_diff = (int) ( ((t_current.time - t_start.time) << 10) + (t_current.millitm - t_start.millitm) );
// 						if(t_diff > max_time)
// 						{
// 							loop_on = 0;
// 							break;
// 						}
// 					}
// 					else
// 						flag_time ++;
// 				}
// 				
// 				p_tree ++;
// 			}
// 		}
// 
// 		p_part ++;
// 	}
// 
// 	if(verbosity & 6)
// 		display_RB();
// 
// 	normalize_RB();
// 
// 	if(verbosity & 6)	
// 		display_RB();
// 
// 	if (max_time && verbosity & 16)
// 		printf("%d iterations undertaken.\n", cur_iter);
// 
// //	dump_graph("spec.dat", "linux.dat");
// //	exit(1);
// }


// Sample on the whole grid
// void sample_general()
// {
// 	int cur_part, cur_tree, cur_node, cur_iter, flag_time = 0, t_diff;
// 	struct timeb t_start, t_current;
// 	Partition *p_part;
// 	Tree *p_tree;
// 
// 	// First, randomly sample the init_tree
// 	for (cur_node = 1; cur_node <= init_tree->num_node; cur_node ++)
// 		node_array[init_tree->local_to_global[cur_node]].num_son = init_tree->num_son[cur_node];
// 	sample_tree(init_tree);
// 
// 	// Second, randomly pick a partition
// 	cur_part = int( ceil( (rand() + 1) / ((double) RAND_MAX + 1) * global_num_partition) + 0.5);
// 	p_part = partitions + cur_part;
// 
// 	// Then stick to that partition
// 	p_tree = p_part->trees + 1;
// 	for (cur_tree = 1; cur_tree <= p_part->num_trees; cur_tree ++)
// 	{
// 		for (cur_node = 1; cur_node <= p_tree->num_node; cur_node ++)
// 			node_array[p_tree->local_to_global[cur_node]].num_son = p_tree->num_son[cur_node];
// 		p_tree ++;
// 	}
// 
// 	if (max_time)
// 	{
// 		flag_time = 1;
// 		ftime(&t_start);
// 	}
// 
// 	for (cur_iter = 1; cur_iter <= max_iter; cur_iter ++)
// 	{
// 		p_tree = p_part->trees + 1;
// 		for (cur_tree = 1; cur_tree <= p_part->num_trees; cur_tree ++)
// 		{
// 			cal_cond_pot(p_tree);
// 			forward_msg_pass(p_tree);
// 			sample_root(p_tree);
// 			backward_sample(p_tree);
// 
// 			if (max_time)
// 			{
// 				if (flag_time == 10)		// check only every 10 iterations
// 				{
// 					flag_time = 1;
// 					ftime(&t_current);
// 
// 					t_diff = (int) ( ((t_current.time - t_start.time) << 10) + (t_current.millitm - t_start.millitm) );
// 					if(t_diff > max_time)
// 						break;
// 				}
// 				else
// 					flag_time ++;
// 			}
// 			p_tree ++;
// 		}
// 	}
// }


// Perform inference on the whole graph using RB
// void infer_ori_tree()
// {
// 	// First define the initial tree
// 	clear_RB();
// 
// 	cal_cond_pot(init_tree);
// 	forward_msg_pass(init_tree);
// 	infer_root(init_tree);
// 	backward_msg_pass(init_tree);
// 
// 	if(verbosity & 6)	
// 		display_RB();
// 
// 	normalize_RB();
// 
// 	if(verbosity & 6)
// 		display_RB();
/*	
	int total = 0;
	for (int i = 2; i < global_num_node; i ++)
	{
		if (node_array[i].sampled_value != 3)
			total ++;
	}
	
	if (cur_step > 250000)
	{
		cout<<total<<":\t";
		for (int i = 1; i <= global_num_node; i ++)
			cout<<node_array[i].sampled_value<<"  ";
		cout<<endl;
	}	
	if (total == 3 && cur_step > 250000)
	{		
		for (int i = 1; i <= global_num_node; i ++)
			cout<<node_array[i].sampled_value<<"  ";
		
		cout<<endl;
		cout<<cur_step<<endl;
		
		dump_graph("input.dat", "result.dat");
		cin.get();
	}
*/
/*	if (cur_step == 100000)
	{
		dump_graph("input.dat", "result.dat");
		cout<<2<<endl;
	cin.get();
	}
*/
/*	if (cur_step % 150000 == 0)
	{
		int i, j, k;
		double ***check, sum;

		dump_graph("input.dat", "result.dat");

		check = new double **[global_num_edge + 1];
		for (i = 1; i <= global_num_edge; i ++)
		{
			check[i] = new double * [num_class + 1];
			for (j = 1; j <= num_class; j ++)
			{
				check[i][j] = new double [num_class + 1];
				for (k = 1; k <= num_class; k ++)
					check[i][j][k] = 0;					
			}
		}
	cout<<1<<endl;
	cout.flush();
			
		for (i = 1; i <= 10000; i ++)
		{
//	cout<<3<<endl;
//	cout.flush();
			sample_ori_tree();
//	cout<<4<<endl;
//	cout.flush();
			for (j = 1; j <= global_num_edge; j ++)
			{
				check[j][edge_array[j].p_node[1]->sampled_value][edge_array[j].p_node[2]->sampled_value] += 1;
			}
		}
	
	cout<<2<<endl;
	cout.flush();
		for (i = 1; i <= global_num_edge; i ++)
		{			
			sum = 0;
			for (j = 1; j <= num_class; j ++)
				for (k = 1; k <= num_class; k ++)
					sum += check[i][j][k];

			cout<<edge_array[i].p_node[1]-node_array<<" -> "<<edge_array[i].p_node[2]-node_array<<endl;
			for (j = 1; j <= num_class; j ++)
			{
				for (k = 1; k <= num_class; k ++)
				{
					check[i][j][k] /= sum;
					cout<<check[i][j][k]<<"\t";
				}
				cout<<endl;
			}
			cout<<endl;
		}

		cout<<"Wait"<<endl;
		cin.get();
	}
*/
// }


// Perform inference on the whole graph using RB
// void sample_ori_tree()
// {
// 	cal_cond_pot(init_tree);
// 	forward_msg_pass(init_tree);
// 	sample_root(init_tree);
// 	backward_sample(init_tree);
// /*
// 	cout<<1<<endl;
// 	dump_graph("input.dat", "result.dat");
// 	cin.get();
// */
// }


// void infer_graph()
// {
// 	if (topo_id == 2 || topo_id == 3)			// grid and circle (all non-trees for which TREE_MCMC is needed)
// 		infer_general();
// 	else if (topo_id == 1 || topo_id == 4)		//  Chain or cross (actually all trees for which exact and efficient inference is possible)
// 		infer_ori_tree();
// 	else
// 	{
// 		cout<<"In infer_graph, unforseen topology type.  Abort."<<endl;
// 		exit(1);
// 	}
// }
// 
// 
// void sample_graph()
// {
// 	if (topo_id == 2 || topo_id == 3)			// grid and circle (all non-trees for which TREE_MCMC is needed)
// 		sample_general();
// 	else if (topo_id == 1 || topo_id == 4)		//  Chain or cross (actually all trees for which exact and efficient inference is possible)
// 		sample_ori_tree();
// 	else
// 	{
// 		cout<<"In sample_graph, unforseen topology type.  Abort."<<endl;
// 		exit(1);
// 	}
// }


// After calculating the RB estimations on the graph,
// Calculate the feature expectations.
void cal_fea_expectation()
{
	// Finally, calculate the node and edge feature expectations
	int cur_node, cur_edge, cur_fea, cur_class_1, cur_class_2, cur_delay, cur_index, rec_start, sample, offset;
	int node1, node2;
	double *rb1, *rb1_2, *fept1, **fept2, ***fept3, **cob2, *cob1, temp;
	Node *p_node;
	Edge *p_edge;

	// First, calculate the node feature expectation
	p_node = node_array + 1;
	fept3 = node_fea_exp + 1;
	offset = 1;
	if (node_step_size > 1e-100)
	{
		cob2 = cur_observation + 1;
		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
		{
			fept2 = *(fept3 ++) + 1;
			rb1 = p_node->rb_est + 1;

			for (cur_class_1 = 1; cur_class_1 <= p_node->num_class; cur_class_1 ++)
			{
				fept1 = *(fept2 ++) + 1;

				cob1 = (*cob2) + 1;
				for (cur_fea = 1; cur_fea <= num_obs_dim; cur_fea ++)
				{
	/*				node_fea_exp[cur_node][cur_class_1][cur_fea]
						= cur_observation[cur_node][cur_fea] * p_node->rb_est[cur_class_1];
	*/
					*(fept1 ++) = *(cob1 ++) * (*rb1);
				}

				rb1 ++;
			}

			p_node ++;		cob2 ++;
		}
	}
	else
	{
		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
		{
			fept2 = *(fept3 ++) + 1;

			for (cur_class_1 = 1; cur_class_1 <= p_node->num_class; cur_class_1 ++)
			{
				fept1 = *(fept2 ++) + 1;

				for (cur_fea = 1; cur_fea <= num_obs_dim; cur_fea ++)
					*(fept1 ++) = 0;
			}
		}	
	}

	//////////////////////////////////////////////////////////////////////////
	// For extra node feature only
	if (num_node_extra_fea)	
	{
		if (fea_id == 2)
		{
			fept2 = node_extra_fea_exp + 1;
			p_node = node_array + 1;
			for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
			{
				rb1 = p_node->rb_est + 1;
				*(*(fept2 ++) + 1) = *(rb1 + 1) + *(rb1 + 2) + 2 * (*(rb1 + 3) + *(rb1 + 4) + *(rb1 + 5));
				p_node ++;
			}
		}
		else if (fea_id == 3)
		{
			fept2 = node_extra_fea_exp + 1;
			p_node = node_array + 1;
			for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
			{
				rb1 = p_node->rb_est + 1;
				*(*(fept2 ++) + 1) = *(rb1 + 1) + *(rb1 + 2);
				p_node ++;
			}
		}
	}

	// Second, calculate the edge feature expectation
	p_edge = edge_array + 1;
	fept2 = edge_fea_exp + 1;

	if (fea_id == 4)
	{
		rec_start = cur_step % max_delay;
		if(!rec_start)
			rec_start = max_delay;

		for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)		// loop over edges
		{
			fept1 = *(fept2 ++) + 1;

			if (edge_fea_sel & 1)		// Using binary constant edge bias
			{
				*fept1 = 0.0;

				for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					 *fept1 += p_edge->rb_est[cur_class_1][cur_class_1];
				fept1 ++;
			}

			if (edge_fea_sel & 2)		// Using square matrix constant edge bias
			{
				cob2 = p_edge->rb_est;
				for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					for (cur_class_2 = 1; cur_class_2 <= num_class; cur_class_2 ++)
						*(fept1 ++) = cob2[cur_class_1][cur_class_2];
			}

			if (cur_step > max_delay && (edge_fea_sel & 60))
			{
				rb1 = p_edge->p_node[1]->rb_est;
				rb1_2 = p_edge->p_node[2]->rb_est;
				node1 = p_edge->p_node[1] - node_array;
				node2 = p_edge->p_node[2] - node_array;

				cur_index = rec_start;
				for (cur_delay = min_delay; cur_delay <= max_delay; cur_delay ++, cur_index ++)
				{
					if (edge_fea_sel & 4)		// First, 1 past, 2 current (ONE feature)					
						*(fept1 ++) = rb1_2[history_action[node1][cur_index]];
					
					if (edge_fea_sel & 8)		// Second, 1 past, 2 current (square matrix)
					{						
						// First, 1 past, 2 current
						sample = history_action[node1][cur_index];					
						fept1 += (sample - 1) * num_class;
						for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
							*(fept1 ++) = rb1_2[cur_class_1];
						fept1 += (num_class - sample) * num_class;
					}

					if (edge_fea_sel & 16)		// Third, 1 current, 2 past (ONE feature)
						*(fept1 ++) = rb1[history_action[node2][cur_index]];

					if (edge_fea_sel & 32)		// Fourth, 1 current, 2 past (square matrix)
					{
						// Second, 1 current, 2 past
						sample = history_action[node2][cur_index];
						fept1 += (sample - 1) * num_class;
						for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
							*(fept1 ++) = rb1[cur_class_1];
						fept1 += (num_class - sample) * num_class;
					}

					if (cur_index == max_delay)
						cur_index = 0;
				}
			}
			p_edge ++;
		}
	}	
	else if (fea_id == 1)		// For Grid grid and traffic with ONE edge feature
	{
		for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
		{	
			fept1 = * (fept2 ++) + offset;
			*fept1 = 0.0;

/*			Most general and advanced case
			rb2 = p_edge->rb_est + 1;

			for (cur_class_1 = 1; cur_class_1 <= num_edge_fea; cur_class_1 ++)
			{
				rb1 = *(rb2++) + 1;
				for (cur_class_1 = 1; cur_class_1 <= num_edge_fea; cur_class_1 ++)
				{
//					edge_fea_ept[cur_edge][cur_fea]
//								+= edge_fea_fn_k(cur_class_1, cur_class_2) * p_edge->rb_est[cur_class_1][cur_class_2];

					*fept1 += edge_fea_fn(cur_fea, cur_class_1, cur_class_2) * (*rb1++);	
				}
			}
			Most general and advanced case
*/
			for (cur_class_1 = 1; cur_class_1 <= p_edge->p_node[1]->num_class; cur_class_1 ++)
				 *fept1 += p_edge->rb_est[cur_class_1][cur_class_1];
			*fept1 *= edge_fea_intensity;

			p_edge ++;
		}
	}
	else if (fea_id == 2)		// For Sensor with 1 Chain (supernodes)
	{
		for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
		{
			fept1 = * (fept2 ++) + offset;
			*(fept1 ++) = (p_edge->rb_est[3][5] + p_edge->rb_est[4][5] + p_edge->rb_est[6][2] + 
							p_edge->rb_est[6][4] + p_edge->rb_est[6][5]) * edge_fea_intensity;				
			p_edge ++;
		}
	}
	else if (fea_id == 3)		// For Sensor with circle (original nodes)
	{
		// 1st, upper and lower row
		for (cur_edge = 2; cur_edge < global_num_edge; cur_edge ++)
		{
			fept1 = * (fept2 ++) + offset + 2;

			temp = p_edge->rb_est[3][2] * edge_fea_intensity;
			*(fept1 --) = temp;
			*fept1 = (p_edge->rb_est[1][2] + p_edge->rb_est[2][2] 
							+ p_edge->rb_est[3][1] + p_edge->rb_est[3][3]) * edge_fea_intensity;
			temp += *(fept1 --);
			*fept1 = edge_fea_intensity - temp;

			p_edge ++;
		}

		// 2nd, the left end top-bottom pair
		fept1 = * (fept2 ++) + offset + 2;

		temp = p_edge->rb_est[3][3] * edge_fea_intensity;
		*(fept1 --) = temp;
		*fept1 = (p_edge->rb_est[1][3] + p_edge->rb_est[2][3] 
						+ p_edge->rb_est[3][1] + p_edge->rb_est[3][2]) * edge_fea_intensity;
		temp += *(fept1 --);
		*fept1 = edge_fea_intensity - temp;
		p_edge ++;

		// 3rd, the right end top-bottom pair
		fept1 = * (fept2 ++) + offset + 2;

		temp = p_edge->rb_est[2][2] * edge_fea_intensity;
		*(fept1 --) = temp;
		*fept1 = (p_edge->rb_est[1][2] + p_edge->rb_est[2][1] 
						+ p_edge->rb_est[2][3] + p_edge->rb_est[3][2]) * edge_fea_intensity;
		temp += *(fept1 --);
		*fept1 = edge_fea_intensity - temp;
	}
}


/************************************************************************/
/*     A lot of initializations (some are grid specific)                */
/************************************************************************/


// void alloc_adj_matrix_grid()
// {
// 	int cur_row, cur_col, i, j, cur_node, *temp;
// 
// 	adj_matrix = new int * [global_num_node + 1];
// 	for (i = 1; i <= global_num_node; i ++)
// 	{
// 		adj_matrix[i] = new int [global_num_node + 1];
// 		temp = adj_matrix[i] + 1;
// 		for (j = 1; j <= global_num_node; j ++)
// 			*(temp++) = 0;
// 	}
// 
// 	cur_node = 1;
// 	for (cur_row = 1; cur_row <= num_row; cur_row ++)
// 	{
// 		for (cur_col = 1; cur_col < num_col; cur_col ++)
// 		{
// 			adj_matrix[cur_node][cur_node + 1] = 1;
// 			adj_matrix[cur_node + 1][cur_node] = 1;
// 			cur_node ++;
// 		}
// 		cur_node ++;   
// 	}
// 
// 	cur_node = 1;
// 	i = num_col + 1;
// 	for (cur_row = 1; cur_row < num_row; cur_row ++)
// 	{
// 		for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 		{
// 			adj_matrix[cur_node][i] = 1;
// 			adj_matrix[i++][cur_node++] = 1;
// 		}
// 	}
// 
// /*
// 	for (cur_row = 1; cur_row <= global_num_node; cur_row ++)
// 	{
// 		for (cur_col = 1; cur_col <= global_num_node; cur_col ++)
// 		{
// 			printf("%d\t", adj_matrix[cur_row][cur_col]);	
// 		}
// 		printf("\n");
// 	}
// */
// }


// void alloc_adj_matrix_chain()
// {
// 	int i, j;
// 
// 	adj_matrix = new int * [global_num_node + 1];
// 	for (i = 1; i <= global_num_node; i ++)
// 	{
// 		adj_matrix[i] = new int [global_num_node + 1];
// 		for (j = 1; j < i - 1; j ++)
// 			adj_matrix[i][j] = 0;
// 		if (i > 1)
// 			adj_matrix[i][i - 1] = 1;
// 		adj_matrix[i][i] = 0;
// 		if (i < global_num_node)
// 			adj_matrix[i][i + 1] = 1;
// 		for (j = i + 2; j <= global_num_node; j ++)
// 			adj_matrix[i][j] = 0;
// 	}
// }


// void alloc_adj_matrix_circle()
// {
// 	int i, j;
// 
// 	adj_matrix = new int * [global_num_node + 1];
// 
// 	for (i = 1; i <= global_num_node; i ++)
// 	{
// 		adj_matrix[i] = new int [global_num_node + 1];
// 		for (j = 1; j <= global_num_node; j ++)
// 			adj_matrix[i][j] = 0;
// 	}
// 
// 	adj_matrix[1][2] = 1;
// 	for (i = 2; i < num_col; i ++)
// 		adj_matrix[i][i - 1] = adj_matrix[i][i + 1] = 1;
// 	adj_matrix[num_col][num_col - 1] = 1;
// 
// 	adj_matrix[num_col + 1][num_col + 2] = 1;
// 	for (i = num_col + 2; i < global_num_node; i ++)
// 		adj_matrix[i][i - 1] = adj_matrix[i][i + 1] = 1;
// 	adj_matrix[global_num_node][global_num_node - 1] = 1;
// 
// 	adj_matrix[num_col + 1][1] = adj_matrix[1][num_col + 1] = 1;
// 	adj_matrix[num_col][global_num_node] = adj_matrix[global_num_node][num_col] = 1;		
// }


// void alloc_adj_matrix_cross()
// {
// 	int i, j, cur_item;
// 	int *temp_id;
// 
// 	temp_id = new int [num_row + 1];
// 	for (i = 1; i <= num_cross_upper; i ++)
// 		temp_id[i] = i;
// 	temp_id[i ++] = num_cross_upper + cross_hori_id;
// 	cur_item = num_col + num_cross_upper + 1;
// 	for (; i <= num_row; i ++)
// 		temp_id[i] = cur_item ++;
// 
// 	adj_matrix = new int * [global_num_node + 1];
// 	for (i = 1; i <= global_num_node; i ++)
// 	{
// 		adj_matrix[i] = new int [global_num_node + 1];
// 		for (j = 1; j <= global_num_node; j ++)
// 			adj_matrix[i][j] = 0;
// 	}
// 
// 	adj_matrix[num_cross_upper + 1][num_cross_upper + 2] = 1;
// 	for (i = num_cross_upper + 2; i < num_cross_upper + num_col; i ++)
// 		adj_matrix[i][i - 1] = adj_matrix[i][i + 1] = 1;
// 	adj_matrix[num_cross_upper + num_col][num_cross_upper + num_col - 1] = 1;
// 
// 	adj_matrix[temp_id[1]][temp_id[2]] = 1;
// 	for (i = 2; i < num_row; i ++)
// 		adj_matrix[temp_id[i]][temp_id[i - 1]] = adj_matrix[temp_id[i]][temp_id[i + 1]] = 1;
// 	adj_matrix[temp_id[num_row]][temp_id[num_row - 1]] = 1;
// 
// 	delete []temp_id;
// }


// void alloc_adj_matrix()
// {
// 	switch(topo_id)
// 	{
// 		case 1:
// 			alloc_adj_matrix_chain();
// 			break;
// 		case 2:
// 			alloc_adj_matrix_grid();
// 			break;
// 		case 3:
// 			alloc_adj_matrix_circle();
// 			break;
// 		case 4:
// 			alloc_adj_matrix_cross();
// 			break;	
// 		default:
// 			cout<<"In alloc_adj_matrix, unforseen topo_id: "<<topo_id<<".  Abort."<<endl;
// 			exit(1);
// 	}
// }


// allocate space for cur_observation, node_fea_para, edge_fea_para, node_fea_grad, edge_fea_grad
// void alloc_fea()
// {
// 	int cur_node, cur_class, cur_edge;
// 	double **pd2, ***pd3;
// 	
// 	// First, cur_observation
// 	cur_observation = new double *[global_num_node + 1];
// 	pd2 = cur_observation + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		*(pd2 ++) = new double [num_obs_dim + 1];
// 
// 	// Second, node_fea_para[1][2][3]
// 	//		First index: node id;	second index: label;	third index: observation dimension
// 	node_fea_para = new double **[global_num_node + 1];
// 	pd3 = node_fea_para + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		*pd3 = new double * [num_class + 1];
// 		pd2 = *(pd3 ++) + 1;
// 		for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 			*(pd2 ++) = new double [num_obs_dim + 1];
// 	}
// 
// 	// Third, node_fea_trace[1][2][3]
// 	//		First index: node id;	second index: label;	third index: observation dimension
// 	node_fea_trace = new double **[global_num_node + 1];
// 	pd3 = node_fea_trace + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		*pd3 = new double * [num_class + 1];
// 		pd2 = *(pd3 ++) + 1;
// 		for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 			*(pd2 ++) = new double [num_obs_dim + 1];
// 	}
// 
// 	// Fourth, node_fea_exp[1][2][3]
// 	//		First index: node id;	second index: label;	third index: observation dimension
// 	node_fea_exp = new double **[global_num_node + 1];
// 	pd3 = node_fea_exp + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		*pd3 = new double * [num_class + 1];
// 		pd2 = *(pd3 ++) + 1;
// 		for (cur_class = 1; cur_class <= num_class; cur_class ++)
// 			*(pd2 ++) = new double [num_obs_dim + 1];
// 	}
// 
// 	if (num_node_extra_fea)
// 	{
// 		// Second_2, node_extra_fea_para[1][2]
// 		//	  First index: node id;		second index: feature index
// 		node_extra_fea_para = new double * [global_num_node + 1];
// 		pd2 = node_extra_fea_para + 1;
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 			*(pd2 ++) = new double [num_node_extra_fea + 1];
// 
// 		// Third_2, node_extra_fea_trace[1][2]
// 		//	  First index: node id;		second index: feature index
// 		node_extra_fea_trace = new double * [global_num_node + 1];
// 		pd2 = node_extra_fea_trace + 1;
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 			*(pd2 ++) = new double [num_node_extra_fea + 1];
// 
// 		// Fourth_2, node_extra_fea_exp[1][2]
// 		//	  First index: node id;		second index: feature index
// 		node_extra_fea_exp = new double * [global_num_node + 1];
// 		pd2 = node_extra_fea_exp + 1;
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 			*(pd2 ++) = new double [num_node_extra_fea + 1];
// 	}
// 
// 	// Fifth, edge_fea_para[1][2]
// 	//	  First index: edge id;		second index: feature index
// 	edge_fea_para = new double * [global_num_edge + 1];
// 	pd2 = edge_fea_para + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 		*(pd2 ++) = new double [num_edge_fea + 1];
// 
// 	// Sixth, edge_fea_trace[1][2]
// 	//	  First index: edge id;		second index: feature index
// 	edge_fea_trace = new double * [global_num_edge + 1];
// 	pd2 = edge_fea_trace + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 		*(pd2 ++) = new double [num_edge_fea + 1];
// 
// 	// Seventh, edge_fea_exp[1][2]
// 	//	  First index: edge id;		second index: feature index
// 	edge_fea_exp = new double * [global_num_edge + 1];
// 	pd2 = edge_fea_exp + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 		*(pd2 ++) = new double [num_edge_fea + 1];
// 
// 	if (edge_fea_sel & 60)
// 	{
// 		history_action = new int * [global_num_node + 1];
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 			history_action[cur_node] = new int [max_delay + 1];
// 	}
// }


// void alloc_potentials()
// {
// 	int cur_item, cur_class_1, cur_class_2, cur_order;
// 	Node *p_node;
// 	Edge *p_edge;
// 
// 	node_array = new Node[global_num_node + 1];
// 	edge_array = new Edge[global_num_edge + 1];
// 
// 	p_node = node_array + 1;
// 	for (cur_item = 1; cur_item <= global_num_node; cur_item++)
// 	{
// 		p_node->cond_pot = new double [num_class + 1];
// 		p_node->rb_est = new double [num_class + 1];
// 		p_node->node_pot = new double [num_class + 1];
// 		p_node->sum_msg = new double [num_class + 1];
// 		p_node->num_class = num_class;
// 		p_node->max_num_son = 0;
// 		p_node ++;
// 	}
// 
// 	p_edge = edge_array + 1;
// 	for (cur_item = 1; cur_item <= global_num_edge; cur_item++)
// 	{
// 		p_edge->rb_est = new double * [num_class + 1];
// 		for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
// 			p_edge->rb_est[cur_class_1] = new double [num_class + 1];
// 
// 		for (cur_order = 1; cur_order <= 2; cur_order ++)
// 		{
// 			p_edge->edge_pot[cur_order] = new double * [num_class + 1];
// 			for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
// 			{
// 				p_edge->edge_pot[cur_order][cur_class_1] = new double [num_class + 1];
// 				for (cur_class_2 = 1; cur_class_2 <= num_class; cur_class_2++)
// 					p_edge->edge_pot[cur_order][cur_class_1][cur_class_2] = 0.0;
// 			}
// 		}
// 		p_edge ++;
// 	}
// }


// Now associate edges with nodes
// void associate_edge_with_nodes_grid()
// {
// 	int cur_node, cur_row, cur_col, cur_node_2;
// 	Edge *p_edge;
// 
// 	p_edge = edge_array + 1;
// 	cur_node = 1;
// 	for (cur_row = 1; cur_row <= num_row; cur_row ++)
// 	{
// 		for (cur_col = 1; cur_col < num_col; cur_col ++)
// 		{
// 			p_edge->p_node[1] = node_array + cur_node;
// 			cur_node ++;
// 			p_edge->p_node[2] = node_array + cur_node;			
// 			p_edge ++;
// 		}
// 		cur_node ++;
// 	}
// 
// 	cur_node = 1;
// 	cur_node_2 = num_col + 1;
// 	for (cur_row = 1; cur_row < num_row; cur_row ++)
// 	{
// 		for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 		{
// 			p_edge->p_node[1] = node_array + cur_node++;
// 			p_edge->p_node[2] = node_array + cur_node_2++;			
// 			p_edge ++;
// 		}
// 	}
// }


// Now associate edges with nodes
// void associate_edge_with_nodes_chain()
// {
// 	int cur_item;
// 	Edge *p_edge;
// 
// 	p_edge = edge_array + 1;
// 	for (cur_item = 1; cur_item < global_num_node; cur_item ++)
// 	{
// 		p_edge->p_node[1] = node_array + cur_item;
// 		p_edge->p_node[2] = node_array + cur_item + 1;
// 		p_edge ++;
// 	}
// }


// Now associate edges with nodes
// void associate_edge_with_nodes_circle()
// {
// 	int cur_item;
// 	Edge *p_edge;
// 
// 	p_edge = edge_array + 1;
// 	for (cur_item = 1; cur_item < num_col; cur_item ++)
// 	{
// 		p_edge->p_node[1] = node_array + cur_item;
// 		p_edge->p_node[2] = node_array + cur_item + 1;
// 		p_edge ++;
// 	}
// 
// 	for (cur_item ++; cur_item < global_num_node; cur_item ++)
// 	{
// 		p_edge->p_node[1] = node_array + cur_item;
// 		p_edge->p_node[2] = node_array + cur_item + 1;
// 		p_edge ++;
// 	}
// 
// 	p_edge->p_node[1] = node_array + 1;
// 	p_edge->p_node[2] = node_array + num_col + 1;
// 	p_edge ++;
// 	p_edge->p_node[1] = node_array + num_col;
// 	p_edge->p_node[2] = node_array + global_num_node;
// }


// Now associate edges with nodes
// void associate_edge_with_nodes_cross()
// {
// 	int cur_item, i;
// 	int *temp_id;
// 	Edge *p_edge;
// 
// 	temp_id = new int [num_row + 1];
// 	for (i = 1; i <= num_cross_upper; i ++)
// 		temp_id[i] = i;
// 	temp_id[i ++] = num_cross_upper + cross_hori_id;
// 	cur_item = num_col + num_cross_upper + 1;
// 	for (; i <= num_row; i ++)
// 		temp_id[i] = cur_item ++;
// 
// 	p_edge = edge_array + 1;
// 	for (cur_item = num_cross_upper + 1; cur_item < num_cross_upper + num_col; cur_item ++)
// 	{
// 		p_edge->p_node[1] = node_array + cur_item;
// 		p_edge->p_node[2] = node_array + cur_item + 1;
// 		p_edge ++;
// 	}
// 
// 	p_edge = edge_array + num_col;
// 	for (cur_item = 1; cur_item < num_row; cur_item ++)
// 	{
// 		p_edge->p_node[1] = node_array + temp_id[cur_item];
// 		p_edge->p_node[2] = node_array + temp_id[cur_item + 1];
// 		p_edge ++;
// 	}
// 
// 	delete []temp_id;
// }


// Now associate edges with nodes
// void associate_edge_with_nodes()
// {
// 	switch(topo_id)
// 	{
// 		case 1:
// 			associate_edge_with_nodes_chain();
// 			break;
// 		case 2:
// 			associate_edge_with_nodes_grid();
// 			break;
// 		case 3:
// 			associate_edge_with_nodes_circle();			
// 			break;
// 		case 4:
// 			associate_edge_with_nodes_cross();
// 			break;
// 		default:
// 			cout<<"In associate_edge_with_nodes, unforseen topo_id: "<<topo_id<<".  Abort."<<endl;
// 			exit(1);
// 	}
// }


// Randomly initialize the edge_fea_para[1][2]
//		First index: edge id;	second index: feature index
// For debug only.
// void set_cur_obs_debug()
// {
// 	int cur_node, cur_obs_dim;
// 	double **p_obs2, *p_obs1;
// 	
// 	p_obs2 = cur_observation + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		p_obs1 = *(p_obs2 ++) + 1;
// 
// 		for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
// 			*(p_obs1 ++) = 0.0;		// cur_observation[cur_node][cur_obs_dim] = 0;
// 	}
// 
// 	cur_observation[1][2] = 1;
// }


// Fill up the node_fea_para[1][2][3]
//		First index: node id;	second index: label;	third index: observation 
// For debug only.
// void set_node_fea_para_debug()
// {
// 	int cur_node, cur_class, cur_obs_dim;
// 	double ***nfp3, **nfp2, *nfp1;
// 	Node *p_node;
// 	
// 	nfp3 = node_fea_para + 1;
// 	p_node = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		nfp2 = *(nfp3 ++) + 1;
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
// 			{
// 				// node_fea_para[cur_node][cur_class][cur_obs_dim];
// 				*(nfp1 ++) = (cur_class == cur_obs_dim);
// 			}
// 		}
// 		p_node ++;
// 	}
// }


// Fill up the edge_fea_para[1][2]
//		First index: edge id;	second index: feature index
// For debug only.
// void set_edge_fea_para_debug()
// {
// 	int cur_edge, cur_fea;
// 	double **efp2, *efp1;
// 
// 	efp2 = edge_fea_para + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		efp1 = *(efp2 ++) + 1;
// 		for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)
// 		{
// 			*(efp1 ++) = -1;		// Encourage edge ends to be different
// 		}
// 	}
// }


/*
// Randomly initialize the node_fea_para[1][2][3]
//		First index: node id;	second index: label;	third index: observation 
void randomize_node_fea_para()
{
	int cur_node, cur_class, cur_obs_dim;
	double ***nfp3, **nfp2, *nfp1;
	Node *p_node;
	
	nfp3 = node_fea_para + 1;
	p_node = node_array + 1;
	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
	{
		nfp2 = *(nfp3 ++) + 1;
		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
		{
			nfp1 = *(nfp2 ++) + 1;
			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
			{
				// node_fea_para[cur_node][cur_class][cur_obs_dim];
				*(nfp1 ++) = maxNodeRand / RAND_MAX * (rand() - RAND_MAX / 2) * 2;
			}
		}
		p_node ++;
	}

	//////////////////////////////////////////////////////////////////////////
	// For node extra feature
	if (num_node_extra_fea)
	{
		nfp2 = node_extra_fea_para + 1;		
		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
		{
			nfp1 = *(nfp2 ++) + 1;
			for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
				*(nfp1 ++) = maxNodeRand / RAND_MAX * (rand() - RAND_MAX / 2) * 2;
		}
	}
}
*/

// Randomly initialize the node_fea_para[1][2][3]
//		First index: node id;	second index: label;	third index: observation 
// void randomize_node_fea_para()
// {
// 	int cur_node, cur_class, cur_obs_dim;
// 	double ***nfp3, **nfp2, *nfp1;
// 	Node *p_node;
// 	
// 	nfp3 = node_fea_para + 1;
// 	p_node = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		nfp2 = *(nfp3 ++) + 1;
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
// 			{
// 				// node_fea_para[cur_node][cur_class][cur_obs_dim];
// 				*(nfp1 ++) = maxNodeRand / RAND_MAX * (rand() - RAND_MAX / 2) * 2;
// 			}
// 		}
// 		p_node ++;
// 	}
// 
// //	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// //		node_fea_para[cur_node][3][1] = 30;
// // changed
// //	node_fea_para[2][3][1] = 100;
// 
// 	//////////////////////////////////////////////////////////////////////////
// 	// For node extra feature
// 	if (num_node_extra_fea)
// 	{
// 		nfp2 = node_extra_fea_para + 1;		
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
// 				*(nfp1 ++) = maxNodeRand / RAND_MAX * (rand() - RAND_MAX / 2) * 2;
// 		}
// 	}
// }



// Randomly initialize the edge_fea_para[1][2]
//		First index: edge id;	second index: feature index
// void randomize_edge_fea_para()
// {
// 	int cur_edge, cur_fea;
// 	double **efp2, *efp1;
// 
// 	efp2 = edge_fea_para + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		efp1 = *(efp2 ++) + 1;
// 		for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)		
// 			*(efp1 ++) = maxEdgeRand / RAND_MAX * (rand() - RAND_MAX / 2) * 2;
// /*
// 		if (cur_edge > 1 && cur_edge < global_num_edge)
// 		{
// 			efp1 = *(efp2 - 1); 
// 			for (cur_fea = 1; cur_fea <= num_class; cur_fea ++)
// 			{
// 				*(efp1 + (cur_fea - 1) * num_class + cur_fea) = 100;
// 			}
// 		}
// */
// 	}
// }


// void reset_trace() 
// { 
// 	int cur_node, cur_fea, cur_edge, cur_class, cur_obs_dim;
// 	double ***nfp3, **nfp2, *nfp1, **efp2, *efp1;
// 	Node *p_node;
// 	
// 	//  First, nodes
// 	nfp3 = node_fea_trace + 1;
// 	p_node = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		nfp2 = *(nfp3 ++) + 1;
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
// 			{
// 				// node_fea_para[cur_node][cur_class][cur_obs_dim];
// 				*(nfp1 ++) = 0;
// 			}
// 		}
// 		p_node ++;
// 	}
// 
// 	// If possible, extra node features
// 	if (num_node_extra_fea)
// 	{
// 		nfp2 = node_extra_fea_trace + 1;		
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
// 				*(nfp1 ++) = 0;
// 		}
// 	}
// 
// 	//  Second, edges
// 	efp2 = edge_fea_trace + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		efp1 = *(efp2 ++) + 1;
// 		for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)
// 		{
// 			*(efp1 ++) = 0;		// Encourage edge ends to be different
// 		}
// 	}
// }


// Discount the trace by factor discount
// void discount_trace(double discount) 
// {
// 	int cur_node, cur_fea, cur_edge, cur_class, cur_obs_dim;
// 	double ***nfp3, **nfp2, *nfp1, **efp2, *efp1;
// 	Node *p_node;
// 
// 	//  First, nodes
// 	nfp3 = node_fea_trace + 1;
// 	p_node = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		nfp2 = *(nfp3 ++) + 1;
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
// 			{
// 				// node_fea_para[cur_node][cur_class][cur_obs_dim];
// 				*(nfp1 ++) *= discount;		 // update node feature grads, node_fea_para[i][j][k]
// 			}
// 		}
// 		p_node ++;
// 	}
// 
// 	// If possible, extra node features
// 	if (num_node_extra_fea)
// 	{
// 		nfp2 = node_extra_fea_trace + 1;		
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
// 				*(nfp1 ++) *= discount;
// 		}
// 	}
// 
// 	//  Second, edges
// 	efp2 = edge_fea_trace + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		efp1 = *(efp2 ++) + 1;
// 		for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)
// 		{
// 			*(efp1 ++) *= discount;			// 	update horizontal edge grads, edge_fea_grad[i*dim_horizontal+j][k]
// 		}
// 	}
// }


// Re-initialize randomly the feature parameters
// void reset_params() 
// {
// 	randomize_node_fea_para();
// 	randomize_edge_fea_para();	
// }


// Get the maximum feature parameter
// double get_max_param() 
// {
// 	int cur_node, cur_fea, cur_edge, cur_class, cur_obs_dim, offset;
// 	double ***nfp3, **nfp2, *nfp1, **efp2, *efp1, record, record1;
// 	Node *p_node;
// 
// 	record = record1 = -1;
// 	string_max_reward[0] = '\0';
// 
// 	//  First, nodes
// 	nfp3 = node_fea_para + 1;
// 	p_node = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		nfp2 = *(nfp3 ++) + 1;
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
// 			{
// 				// node_fea_para[cur_node][cur_class][cur_obs_dim];
// 				if(fabs(*nfp1) > record1)
// 					record1 = fabs(*nfp1);
// 				nfp1 ++;			
// 			}
// 		}
// 		p_node ++;
// 	}
// 
// 	sprintf(string_max_reward, "%5.4g", record1);
// 	if (record1 > record)
// 		record = record1;
// 	record1 = -1;
// 
// 	//  Second, edges
// 	efp2 = edge_fea_para + 1;
// 	offset = num_class * num_class;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		efp1 = *(efp2 ++) + 1;
// 		for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)
// 		{
// 			if(fabs(*efp1) > record1)
// 				record1 = fabs(*efp1);
// 			efp1 ++;
// 		}
// 	}
// 
// 	sprintf(string_max_reward, "%s,   %5.4g", string_max_reward, record1);
// 	if (record1 > record)
// 		record = record1;
// 
// 	// If possible, extra node features
// 	if (num_node_extra_fea)
// 	{
// 		record1 = -1;
// 		nfp2 = node_extra_fea_para + 1;		
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
// 			{
// 				if(fabs(*nfp1) > record1)
// 					record1 = fabs(*nfp1);
// 				nfp1 ++;			
// 			}		
// 		}
// 		sprintf(string_max_reward, "%s   %5.4g", string_max_reward, record1);
// 	}
// 	if (record1 > record)
// 		record = record1;
// 	return -record;
// }


void graph_para_write(std::ostream & o) 
{
	int cur_node, cur_fea, cur_edge, cur_class, cur_class_1, cur_class_2, cur_obs_dim, offset, cur_delay;
	double ***nfp3, **nfp2, *nfp1, **efp2, *efp1;
	Node *p_node;

	//  First, nodes
	nfp3 = node_fea_para + 1;
	p_node = node_array + 1;
	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
	{
		nfp2 = *(nfp3 ++) + 1;
		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
		{
			nfp1 = *(nfp2 ++) + 1;
			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
			{
				// node_fea_para[cur_node][cur_class][cur_obs_dim];
				o << *(nfp1 ++) << "  ";	 // update node feature grads, node_fea_para[i][j][k]
			}
			o << endl;
		}
		o << endl;

		p_node ++;
	}

	// If possible, extra node features
	if (num_node_extra_fea)
	{
		nfp2 = node_extra_fea_para + 1;		
		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
		{
			nfp1 = *(nfp2 ++) + 1;
			for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
				o << *(nfp1 ++) << "  ";
			o << endl;
		}
	}

	//  Second, edges
	efp2 = edge_fea_para + 1;
	offset = num_class * num_class;
	if (fea_id != 4)
	{
		for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
		{
			efp1 = *(efp2 ++) + 1;
			for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)
			{
				o << *(efp1 ++) << "  ";			// 	update horizontal edge grads, edge_fea_grad[i*dim_horizontal+j][k]
				if (fea_id == 7)
				{
					if (cur_fea % 4 == 0)
						o << endl;
					if (cur_fea % 16 == 0)
						o << endl;
				}

			}
			o << endl << endl;
		}
		return;
	}

	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)		// loop over edges
	{
		efp1 = *(efp2 ++) + 1;

		if (edge_fea_sel & 1)		// Using binary constant edge bias
			o << *(efp1 ++) << endl;

		if (edge_fea_sel & 2)		// Using square matrix constant edge bias
		{
			for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
			{
				for (cur_class_2 = 1; cur_class_2 <= num_class; cur_class_2 ++)
					o << *(efp1 ++) <<"  ";
				o<<endl;
			}
			o<<endl;
		}

		if (cur_step > max_delay && (edge_fea_sel & 60))
		{			
			for (cur_delay = min_delay; cur_delay <= max_delay; cur_delay ++)
			{
				if (edge_fea_sel & 4)		// First, 1 past, 2 current (ONE feature)					
					o << *(efp1 ++) << endl;
				
				if (edge_fea_sel & 8)		// Second, 1 past, 2 current (square matrix)
				{						
					for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					{
						for (cur_class_2 = 1; cur_class_2 <= num_class; cur_class_2 ++)
							o << *(efp1 ++) <<"  ";
						o<<endl;
					}
					o<<endl;
				}

				if (edge_fea_sel & 16)		// Third, 1 current, 2 past (ONE feature)
					o << *(efp1 ++) << endl;

				if (edge_fea_sel & 32)		// Fourth, 1 current, 2 past (square matrix)
				{
					for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					{
						for (cur_class_2 = 1; cur_class_2 <= num_class; cur_class_2 ++)
							o << *(efp1 ++) <<"  ";
						o<<endl;
					}
					o<<endl;
				}
			}
		}
	}	
}


// void graph_para_read(std::istream & o) 
// {
// 	int cur_node, cur_fea, cur_edge, cur_class, cur_obs_dim, offset;
// 	double ***nfp3, **nfp2, *nfp1, **efp2, *efp1;
// 	Node *p_node;
// 
// 	//  First, nodes
// 	nfp3 = node_fea_para + 1;
// 	p_node = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		nfp2 = *(nfp3 ++) + 1;
// 		for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
// 			{
// 				// node_fea_para[cur_node][cur_class][cur_obs_dim];
// 				o >> *(nfp1 ++);	 // update node feature grads, node_fea_para[i][j][k]
// 			}
// 		}
// 		p_node ++;
// 	}
// 
// 	// If possible, extra node features
// 	if (num_node_extra_fea)
// 	{
// 		nfp2 = node_extra_fea_para + 1;		
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		{
// 			nfp1 = *(nfp2 ++) + 1;
// 			for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
// 				o >> *(nfp1 ++);
// 		}
// 	}
// 
// 	//  Second, edges
// 	efp2 = edge_fea_para + 1;
// 	offset = num_class * num_class;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		efp1 = *(efp2 ++) + 1;
// 		for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)
// 		{
// 			o >> *(efp1 ++);			// 	update horizontal edge grads, edge_fea_grad[i*dim_horizontal+j][k]
// 		}
// 	}
// }


// void fill_edge_reward_grid(double *reward)
// {
// 	int cur_row, cur_col, cur_node, cur_node_2;
// 	double *cur_edge_reward;
// 
// 	// Horizontal edges
// 	cur_edge_reward = reward + global_num_node + 1;
// 	cur_node = 1;
// 	for (cur_row = 1; cur_row <= num_row; cur_row ++)
// 	{
// 		switch (edge_reward_def)
// 		{
// 		case 1:		// arithmetic mean of two end nodes (default)
// 			for (cur_col = 1; cur_col < num_col; cur_col ++)
// 			{
// 				*(cur_edge_reward ++) = (reward[cur_node] + reward[cur_node + 1]) / 2.0;			
// 				cur_node ++;
// 			}			
// 			break;
// 		case 2:		// geometric mean
// 			for (cur_col = 1; cur_col < num_col; cur_col ++)
// 			{
// 				*(cur_edge_reward ++) = sqrt(reward[cur_node] * reward[cur_node + 1]);
// 				cur_node ++;
// 			}			
// 			break;
// 		case 3:		// min of two end nodes
// 			for (cur_col = 1; cur_col < num_col; cur_col ++)
// 			{
// 				*(cur_edge_reward ++) = min(reward[cur_node], reward[cur_node + 1]);
// 				cur_node ++;
// 			}			
// 			break;
// 		case 4:		// max of two end nodes
// 			for (cur_col = 1; cur_col < num_col; cur_col ++)
// 			{
// 				*(cur_edge_reward ++) = max(reward[cur_node], reward[cur_node + 1]);
// 				cur_node ++;
// 			}			
// 			break;
// 		case 5:		// end node [2]
// 			for (cur_col = 1; cur_col < num_col; cur_col ++)
// 			{
// 				*(cur_edge_reward ++) = reward[cur_node + 1];
// 				cur_node ++;
// 			}			
// 			break;
// 		case 6:		// end node [1]
// 			for (cur_col = 1; cur_col < num_col; cur_col ++)
// 			{
// 				*(cur_edge_reward ++) = reward[cur_node];
// 				cur_node ++;
// 			}
// 			break;
// 		default:
// 			cout<<"Unforseen edge reward def: "<<edge_reward_def<<endl;
// 			exit(1);
// 		}
// 
// 		cur_node ++;
// 	}
// 
// 	// Vertical edges
// 	cur_node = 1;
// 	cur_node_2 = num_col + 1;
// 	for (cur_row = 1; cur_row < num_row; cur_row ++)
// 	{
// 		switch (edge_reward_def)
// 		{
// 		case 1:		// arithmetic mean of two end nodes (default)
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 				*(cur_edge_reward ++) = (reward[cur_node ++] + reward[cur_node_2 ++]) / 2.0;
// 			break;
// 		case 2:		// geometric mean
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 				*(cur_edge_reward ++) = sqrt(reward[cur_node ++] * reward[cur_node_2 ++]);
// 			break;
// 		case 3:		// min of two end nodes
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 				*(cur_edge_reward ++) = min(reward[cur_node ++], reward[cur_node_2 ++]);
// 			break;
// 		case 4:		// max of two end nodes
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 			{
// 				*(cur_edge_reward ++) = max(reward[cur_node ++], reward[cur_node_2 ++]);
// 				cur_node ++;			cur_node_2 ++;
// 			}
// 			break;
// 		case 5:		// end node [2]
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 				*(cur_edge_reward ++) = reward[cur_node_2 ++];
// 			break;
// 		case 6:		// end node [1]
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 				*(cur_edge_reward ++) = reward[cur_node ++];
// 			break;
// 		default:
// 			cout<<"Unforseen edge reward def: "<<edge_reward_def<<endl;
// 			exit(1);
// 		}
// 	}
// }


// void fill_edge_reward_chain(double *reward)
// {
// 	int cur_node;
// 	double *cur_edge_reward;
// 
// 	cur_edge_reward = reward + global_num_node + 1;
// 	switch (edge_reward_def)
// 	{
// 	case 1:		// arithmetic mean of two end nodes (default)
// 		for (cur_node = 1; cur_node < num_col; cur_node ++)
// 			*(cur_edge_reward ++) = (reward[cur_node] + reward[cur_node + 1]) / 2.0;
// 		break;
// 	case 2:		// geometric mean
// 		for (cur_node = 1; cur_node < num_col; cur_node ++)
// 			*(cur_edge_reward ++) = sqrt(reward[cur_node] * reward[cur_node + 1]);
// 		break;
// 	case 3:		// min of two end nodes
// 		for (cur_node = 1; cur_node < num_col; cur_node ++)
// 			*(cur_edge_reward ++) = min(reward[cur_node], reward[cur_node + 1]);
// 		break;
// 	case 4:		// max of two end nodes
// 		for (cur_node = 1; cur_node < num_col; cur_node ++)
// 			*(cur_edge_reward ++) = max(reward[cur_node], reward[cur_node + 1]);
// 		break;
// 	case 5:		// end node [2]
// 		for (cur_node = 1; cur_node < num_col; cur_node ++)
// 			*(cur_edge_reward ++) = reward[cur_node + 1];
// 		break;
// 	case 6:		// end node [1]
// 		for (cur_node = 1; cur_node < num_col; cur_node ++)
// 			*(cur_edge_reward ++) = reward[cur_node];
// 		break;
// 	default:
// 		cout<<"Unforseen edge reward def: "<<edge_reward_def<<endl;
// 		exit(1);
// 	}
// 
// /*	
// 	for (cur_node = 1; cur_node <= num_col; cur_node ++)
// 		cout<<reward[cur_node]<<"  ";
// 	cout<<endl;
// */
// }


// void fill_edge_reward_generic(double *reward)
// {
// 	int cur_edge;
// 	double *cur_reward;
// 	Edge *pEdge;
// 
// 	cur_reward = reward + global_num_node + 1;
// 	pEdge = edge_array + 1;
// 
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		switch (edge_reward_def)
// 		{
// 		case 1:		// arithmetic mean of two end nodes (default)
// 			*(cur_reward ++) = (reward[pEdge->p_node[1] - node_array] + reward[pEdge->p_node[2] - node_array]) / 2;
// 			break;
// 		case 2:		// geometric mean
// 			*(cur_reward ++) = sqrt(reward[pEdge->p_node[1] - node_array] * reward[pEdge->p_node[2] - node_array]);
// 			break;
// 		case 3:		// min of two end nodes
// 			*(cur_reward ++) = min(reward[pEdge->p_node[1] - node_array], reward[pEdge->p_node[2] - node_array]);
// 			break;
// 		case 4:		// max of two end nodes
// 			*(cur_reward ++) = max(reward[pEdge->p_node[1] - node_array], reward[pEdge->p_node[2] - node_array]);
// 			break;
// 		case 5:		// end node [2]
// 			*(cur_reward ++) = reward[pEdge->p_node[2] - node_array];
// 			break;
// 		case 6:		// end node [1]
// 			*(cur_reward ++) = reward[pEdge->p_node[1] - node_array];
// 			break;
// 		default:
// 			cout<<"Unforseen edge reward def: "<<edge_reward_def<<endl;
// 			exit(1);
// 		}
// 
// 		pEdge ++;
// 	}
// }

// Add reward * trace to the feature parameters
// fea_para += reward * fea_trace
// reward[1]: for node features; reward[2]: for edge features; reward[3]: for node extra features
// Source: 1 add from trace, 2: add from grad (exp matrix)
void update_fea_para(double *stepSize, double *reward, int source)
{
	int cur_item, cur_fea, cur_class, cur_obs_dim;
	double ***pd3, **pd2, *pd1, ***pd3_2, **pd2_2 = NULL, *pd1_2, cur_mult, *cur_reward;
	Node *p_node;
	
	if (source == 1)		// from trace
		pd3_2 = node_fea_trace + 1;
	else if (source == 2)	// from grad (by NAC)
		pd3_2 = node_fea_exp + 1;
	else
	{
		cout<<"Unknown source of update_fea_para: "<<source<<".  Can be either 1 for trace, or 2 for grad."<<endl;
		exit(1);
	}

	if (use_local_reward)		// Use local rewards
	{
		if (source == 1)
		{
			switch(topo_id)
			{
			case 1: 
				fill_edge_reward_chain(reward);
				break;
			case 2: 
				fill_edge_reward_grid(reward);
				break;
			default:
				fill_edge_reward_generic(reward);
				break;
			}
		}
		
		//  First, nodes
		if (stepSize[1] > 1e-100)
		{
			pd3 = node_fea_para + 1;
			p_node = node_array + 1;
			cur_reward = reward + 1;
			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				cur_mult = *(cur_reward ++) * stepSize[1];
				pd2 = *(pd3 ++) + 1;
				pd2_2 = *(pd3_2 ++) + 1;

				for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
				{
					pd1 = *(pd2 ++) + 1;
					pd1_2 = *(pd2_2 ++) + 1;

					for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
						*(pd1 ++) += *(pd1_2 ++) * cur_mult;
				}
				p_node ++;
			}
		}
		else
			cur_reward = reward + global_num_node + 1;

		//////////////////////////////////////////////////////////////////////////
		// For extra node feature
		if (num_node_extra_fea)
		{
			if (source == 1)			// from trace
				pd2_2 = node_extra_fea_trace + 1;
			else if (source == 2)		// from grad (by NAC)
				pd2_2 = node_extra_fea_exp + 1;

			pd2 = node_extra_fea_para + 1;
			cur_reward = reward + 1;
			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				cur_mult = *(cur_reward ++) * stepSize[3];
				pd1 = *(pd2 ++) + 1;
				pd1_2 = *(pd2_2 ++) + 1;
				for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
					*(pd1 ++) += *(pd1_2 ++) * cur_mult;
			}
		}

		//  Second, edges
		if (source == 1)		// from trace
			pd2_2 = edge_fea_trace + 1;
		else if (source == 2)	// from grad (by NAC)
			pd2_2 = edge_fea_exp + 1;

		pd2 = edge_fea_para + 1;
		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)
		{
			cur_mult = *(cur_reward ++) * stepSize[2];
			pd1 = *(pd2 ++) + 1;
			pd1_2 = *(pd2_2 ++) + 1;
			for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea++)
				*(pd1 ++) += *(pd1_2 ++) * cur_mult;
		}	
	}
	else		// Use global rewards
	{
		//  First, nodes
		cur_reward = reward + 1;
		if (node_step_size > 1e-100)
		{
			pd3 = node_fea_para + 1;
			p_node = node_array + 1;
			cur_mult = stepSize[1] * (*cur_reward);
			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				pd2 = *(pd3 ++) + 1;
				pd2_2 = *(pd3_2 ++) + 1;

				for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
				{
					pd1 = *(pd2 ++) + 1;
					pd1_2 = *(pd2_2 ++) + 1;

					for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
						*(pd1 ++) += *(pd1_2 ++) * cur_mult;
				}
				p_node ++;
			}
		}

		//////////////////////////////////////////////////////////////////////////
		// For extra node feature
		if (num_node_extra_fea)
		{
			cur_mult = stepSize[3] * (*cur_reward);
			if (source == 1)			// from trace
				pd2_2 = node_extra_fea_trace + 1;
			else if (source == 2)		// from grad (by NAC)
				pd2_2 = node_extra_fea_exp + 1;

			pd2 = node_extra_fea_para + 1;
			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				pd1 = *(pd2 ++) + 1;
				pd1_2 = *(pd2_2 ++) + 1;
				for (cur_class = 1; cur_class <= num_node_extra_fea; cur_class ++)
					*(pd1 ++) += *(pd1_2 ++) * cur_mult;
			}
		}

		//  Second, edges
		if (source == 1)		// from trace
			pd2_2 = edge_fea_trace + 1;
		else if (source == 2)	// from grad (by NAC)
			pd2_2 = edge_fea_exp + 1;

		cur_mult = stepSize[2] * (*cur_reward);
		pd2 = edge_fea_para + 1;
		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)
		{
			pd1 = *(pd2 ++) + 1;
			pd1_2 = *(pd2_2 ++) + 1;

			for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea++)
				*(pd1 ++) += *(pd1_2 ++) * cur_mult;
		}	
	}
}


void record_previous_history()
{
	int cur_item, rec_start;

	rec_start = cur_step % max_delay;
	if(!rec_start)
		rec_start = max_delay;
			
	for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
		history_action[cur_item][rec_start] = current_phase[cur_item];
}


// Add the gradient to the trace
// Implicitly fill the gradient into the exp[] space
void fill_trace()
{
	int cur_item, cur_fea, cur_class, cur_obs_dim, node1, node2, cur_index, rec_start, cur_delay, sample1, sample2, offset;
	double ***pd3, **pd2, *pd1, ***pd3_2, **pd2_2, *pd1_2, **pd2_3, *pd1_3;
	bool flag;
	Node *p_node;
	Edge *p_edge;

	//  First, nodes
	if (node_step_size > 1e-100)
	{
		pd3 = node_fea_trace + 1;
		p_node = node_array + 1;
		pd3_2 = node_fea_exp + 1;
		pd2_3 = cur_observation + 1;
		for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
		{
			pd2 = *(pd3 ++) + 1;
			pd2_2 = *(pd3_2 ++) + 1;

			for (cur_class = 1; cur_class < p_node->sampled_value; cur_class ++)
			{
				pd1 = *(pd2 ++) + 1;
				pd1_2 = *(pd2_2 ++) + 1;

				for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
				{
					*pd1_2 = - *pd1_2;
					*(pd1 ++) += *(pd1_2 ++);
				}
			}

			pd1 = *(pd2 ++) + 1;
			pd1_2 = *(pd2_2 ++) + 1;
			pd1_3 = *(pd2_3 ++) + 1;

			// cur_class == p_node->sampled_value
			for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)			
			{
				*pd1_2 = *(pd1_3 ++) - *pd1_2;
				*(pd1 ++) += *(pd1_2 ++);
			}

			for (cur_class ++; cur_class <= p_node->num_class; cur_class ++)
			{
				pd1 = *(pd2 ++) + 1;
				pd1_2 = *(pd2_2 ++) + 1;

				for (cur_obs_dim = 1; cur_obs_dim <= num_obs_dim; cur_obs_dim ++)
				{
					*pd1_2 = - *pd1_2;
					*(pd1 ++) += *(pd1_2 ++);
				}
			}
			p_node ++;
		}
	}
	
	if (num_node_extra_fea)
	{
		if (fea_id == 2)
		{
			p_node = node_array + 1;
			pd2 = node_extra_fea_trace + 1;
			pd2_2 = node_extra_fea_exp + 1;
			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				pd1_2 = *(pd2_2 ++) + 1;

				*pd1_2 = - *pd1_2;
				if (p_node->sampled_value > 3)
					*pd1_2 += 2;
				else if (p_node->sampled_value > 1)
					*pd1_2 += 1;

				*(*(pd2 ++) + 1) += *pd1_2;

				p_node ++;
			}
		}
		else if (fea_id == 3)
		{
			p_node = node_array + 1;
			pd2 = node_extra_fea_trace + 1;
			pd2_2 = node_extra_fea_exp + 1;
			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				pd1_2 = *(pd2_2 ++) + 1;

				*pd1_2 = - *pd1_2;
				if (p_node->sampled_value > 1)
					*pd1_2 += 1;

				*(*(pd2 ++) + 1) += *pd1_2;

				p_node ++;
			}
		}
	}

	//  Second, edges
	pd2 = edge_fea_trace + 1;
	pd2_2 = edge_fea_exp + 1;
	p_edge = edge_array + 1;
	offset = 1;

	if (fea_id == 4)
	{
		rec_start = cur_step % max_delay;
		if(!rec_start)
			rec_start = max_delay;
		offset = num_class * num_class + 1;

		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)
		{
			pd1 = *(pd2 ++) + 1;
			pd1_2 = *(pd2_2 ++) + 1;

			if (edge_fea_sel & 1)		// Using binary constant edge bias
			{
				if (p_edge->p_node[1]->sampled_value == p_edge->p_node[2]->sampled_value)
				{
					*pd1_2 = 1.0 - *pd1_2;
					*(pd1 ++) += *(pd1_2 ++);
				}
				else
				{
					*pd1_2 = - *pd1_2;
					*(pd1++) += *(pd1_2 ++);
				}
			}

			if (edge_fea_sel & 2)		// Using square matrix constant edge bias
			{
				for (cur_fea = 1; cur_fea < offset; cur_fea ++)			
				{
					*pd1_2 = - *pd1_2;
					*(pd1 ++) += *(pd1_2 ++);
				}

				cur_class = (p_edge->p_node[1]->sampled_value - 1) * num_class
								+ p_edge->p_node[2]->sampled_value - offset;

				*(pd1 + cur_class) += 1;
				*(pd1_2 + cur_class) += 1;
			}

			if (cur_step > max_delay && (edge_fea_sel & 60))
			{
				node1 = p_edge->p_node[1] - node_array;
				node2 = p_edge->p_node[2] - node_array;				

				cur_index = rec_start;
				for (cur_delay = min_delay; cur_delay <= max_delay; cur_delay ++, cur_index ++)
				{
					if (edge_fea_sel & 4)		// First, 1 past, 2 current (ONE feature)	
					{
						if (p_edge->p_node[2]->sampled_value == history_action[node1][cur_index])
						{
							*pd1_2 = 1.0 - *pd1_2;				
							*(pd1 ++) += *(pd1_2 ++);
						}
						else
						{
							*pd1_2 = - *pd1_2;
							*(pd1++) += *(pd1_2 ++);				
						}
					}

					if (edge_fea_sel & 8)		// Second, 1 past, 2 current (square matrix)
					{
						sample1 = history_action[node1][cur_index];
						pd1 += (sample1 - 1) * num_class;
						pd1_2 += (sample1 - 1) * num_class;
						for (cur_class = 1; cur_class <= num_class; cur_class ++)
						{
							*pd1_2 = - *pd1_2;
							*(pd1 ++) += *(pd1_2 ++);
						}

						sample2 = p_edge->p_node[2]->sampled_value - num_class - 1;
						*(pd1_2 + sample2) += 1;
						*(pd1 + sample2) += 1;

						pd1 += (num_class - sample1) * num_class;
						pd1_2 += (num_class - sample1) * num_class;
					}

					if (edge_fea_sel & 16)		// Third, 1 current, 2 past (ONE feature)
					{
						if (p_edge->p_node[1]->sampled_value == history_action[node2][cur_index])
						{
							*pd1_2 = 1.0 - *pd1_2;				
							*(pd1 ++) += *(pd1_2 ++);
						}
						else
						{
							*pd1_2 = - *pd1_2;
							*(pd1++) += *(pd1_2 ++);				
						}
					}

					if (edge_fea_sel & 32)		// Fourth, 1 current, 2 past (square matrix)
					{
						sample1 = history_action[node2][cur_index];
						pd1 += (sample1 - 1) * num_class;
						pd1_2 += (sample1 - 1) * num_class;
						for (cur_class = 1; cur_class <= num_class; cur_class ++)
						{
							*pd1_2 = - *pd1_2;
							*(pd1 ++) += *(pd1_2 ++);
						}

						sample2 = p_edge->p_node[1]->sampled_value - num_class - 1;
						*(pd1_2 + sample2) += 1;
						*(pd1 + sample2) += 1;

						pd1 += (num_class - sample1) * num_class;
						pd1_2 += (num_class - sample1) * num_class;
					}

					if (cur_index == max_delay)
						cur_index = 0;
				}
			}
			p_edge ++;
		}
	}
	else if (fea_id == 1)
	{
		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)
		{
			pd1 = *(pd2 ++) + offset;
			pd1_2 = *(pd2_2 ++) + offset;

			if (p_edge->p_node[1]->sampled_value == p_edge->p_node[2]->sampled_value)
			{
				for (cur_fea = 1; cur_fea < offset; cur_fea++)
				{
					*pd1_2 = edge_fea_intensity - *pd1_2;				
					*(pd1 ++) += *(pd1_2 ++);
	//				*(pd1++) += edge_fea_intensity - *(pd1_2 ++);
				}
			}
			else
			{	
				for (cur_fea = 1; cur_fea < offset; cur_fea++)
				{
					*pd1_2 = - *pd1_2;
					*(pd1++) += *(pd1_2 ++);				
				}
			}
			p_edge ++;
		}
	}
	else if (fea_id == 2)
	{
		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)
		{
			pd1 = *(pd2 ++) + offset;
			pd1_2 = *(pd2_2 ++) + offset;
			sample1 = p_edge->p_node[1]->sampled_value;
			sample2 = p_edge->p_node[2]->sampled_value;

			if (sample1 == 6 && (sample2 == 2 || sample2 == 4 || sample2 == 5)
				|| sample2 == 5 && (sample1 == 3 || sample1 == 4))
			{
				*pd1_2 = edge_fea_intensity - *pd1_2;				
				*(pd1++) += *(pd1_2 ++);
			}
			else
			{
				*pd1_2 = - *pd1_2;
				*(pd1++) += *(pd1_2 ++);
			}
			p_edge ++;
		}
	}
	else if (fea_id == 3)
	{	
		// 1st: upper and lower row
		for (cur_item = 2; cur_item < global_num_node; cur_item ++)
		{
			pd1 = *(pd2 ++) + offset + 2;
			pd1_2 = *(pd2_2 ++) + offset + 2;
			flag = true;

			sample1 = p_edge->p_node[1]->sampled_value;
			sample2 = p_edge->p_node[2]->sampled_value;

			// Feature 2
			if (sample1 == 3 && sample2 == 2)
			{
				flag = false;
				*pd1_2 = edge_fea_intensity - *pd1_2;				
				*(pd1--) += *(pd1_2 --);
			}
			else
			{
				*pd1_2 = - *pd1_2;
				*(pd1--) += *(pd1_2 --);
			}

			// Feature 1
			if (flag && (sample1 == 1 && sample2 == 2 || sample1 == 2 && sample2 == 2 ||
						sample1 == 3 && sample2 == 1 || sample1 == 3 && sample2 == 3))
			{
				flag = false;
				*pd1_2 = edge_fea_intensity - *pd1_2;				
				*(pd1--) += *(pd1_2 --);
			}
			else
			{
				*pd1_2 = - *pd1_2;
				*(pd1--) += *(pd1_2 --);
			}

			// Feature 0
			if (flag)
			{
				*pd1_2 = edge_fea_intensity - *pd1_2;				
				*pd1 += *pd1_2;
			}
			else
			{
				*pd1_2 = - *pd1_2;
				*pd1 += *pd1_2;
			}
			p_edge ++;
		}

		// 2nd, left end pair
		pd1 = *(pd2 ++) + offset + 2;
		pd1_2 = *(pd2_2 ++) + offset + 2;
		flag = true;

		sample1 = p_edge->p_node[1]->sampled_value;
		sample2 = p_edge->p_node[2]->sampled_value;

		// Feature 2
		if (sample1 == 3 && sample2 == 3)
		{
			flag = false;
			*pd1_2 = edge_fea_intensity - *pd1_2;				
			*(pd1--) += *(pd1_2 --);
		}
		else
		{
			*pd1_2 = - *pd1_2;
			*(pd1--) += *(pd1_2 --);
		}

		// Feature 1
		if (flag && (sample1 == 1 && sample2 == 3 || sample1 == 2 && sample2 == 3 ||
					sample1 == 3 && sample2 == 1 || sample1 == 3 && sample2 == 2))
		{
			flag = false;
			*pd1_2 = edge_fea_intensity - *pd1_2;
			*(pd1--) += *(pd1_2 --);
		}
		else
		{
			*pd1_2 = - *pd1_2;
			*(pd1--) += *(pd1_2 --);
		}

		// Feature 0
		if (flag)
		{
			*pd1_2 = edge_fea_intensity - *pd1_2;				
			*pd1 += *pd1_2;
		}
		else
		{
			*pd1_2 = - *pd1_2;
			*pd1 += *pd1_2;
		}
		p_edge ++;


		// 3rd: right end pair
		pd1 = *(pd2 ++) + offset + 2;
		pd1_2 = *(pd2_2 ++) + offset + 2;
		flag = true;

		sample1 = p_edge->p_node[1]->sampled_value;
		sample2 = p_edge->p_node[2]->sampled_value;

		// Feature 2
		if (sample1 == 2 && sample2 == 2)
		{
			flag = false;
			*pd1_2 = edge_fea_intensity - *pd1_2;				
			*(pd1--) += *(pd1_2 --);
		}
		else
		{
			*pd1_2 = - *pd1_2;
			*(pd1--) += *(pd1_2 --);
		}

		// Feature 1
		if (flag && (sample1 == 1 && sample2 == 2 || sample1 == 2 && sample2 == 1 ||
					sample1 == 2 && sample2 == 3 || sample1 == 3 && sample2 == 2))
		{
			flag = false;
			*pd1_2 = edge_fea_intensity - *pd1_2;				
			*(pd1--) += *(pd1_2 --);
		}
		else
		{
			*pd1_2 = - *pd1_2;
			*(pd1--) += *(pd1_2 --);
		}

		// Feature 0
		if (flag)
		{
			*pd1_2 = edge_fea_intensity - *pd1_2;				
			*pd1 += *pd1_2;
		}
		else
		{
			*pd1_2 = - *pd1_2;
			*pd1 += *pd1_2;
		}
	}
}


/**
 *	Set the edge and node potentials of the graph.  
 *	Space allocation has been done by alloc_potentials()
 */
void set_potentials()
{
	int cur_item, cur_fea, cur_class_1, cur_class_2, rec_start, cur_index, cur_delay, node1, node2, sample, offset;
	Node *p_node_1;
	Edge *p_edge;
	double *cur_pot1, *cur_pot2, sum, **obs2, *obs1, ***nfp3, **nfp2, *nfp1, **efp2, *efp1, dtemp;

/*	For most general way to define edge potentials
	double **cur_pot2_1, **cur_pot2_2, *efp1;
	Node *p_node_2;
	int cur_class_2;
*/
	cur_step ++;

	//////////////////////////////////////////////////////////////////////////
	// First Node potentials

	p_node_1 = node_array + 1;
	obs2 = cur_observation + 1;
	nfp3 = node_fea_para + 1;
	if (node_step_size > 1e-100)
	{
		for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
		{
			cur_pot1 = p_node_1->node_pot + 1;
			nfp2 = (*nfp3) + 1;

			for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
			{
				sum = 0.0;
				obs1 = (*obs2) + 1;
				nfp1 = (*nfp2) + 1;
				for (cur_fea = 1; cur_fea <= num_obs_dim; cur_fea ++)
				{
					//	sum += cur_observation[cur_node][cur_fea] * node_fea_para[cur_node][cur_class][cur_fea];
					sum += (*obs1) * (*nfp1);
					obs1 ++;		nfp1++;
				}

				if (maxNodeRand < 0)
					cout<<cur_class_1<<"\t"<<sum<<endl;
				*(cur_pot1 ++) = sum;
				nfp2 ++;
			}
			
			if (fabs(bias) > 1e-5)
				p_node_1->node_pot[cur_step % cycleTime / stepsPerControl + 1] += bias;

			p_node_1 ++;
			obs2 ++;	nfp3 ++;
		}
	}
	else
	{
		for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
		{
			cur_pot1 = p_node_1->node_pot + 1;

			for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
				*(cur_pot1 ++) = 0.0;
			
			if (fabs(bias) > 1e-5)
				p_node_1->node_pot[cur_step % cycleTime / stepsPerControl + 1] += bias;

			p_node_1 ++;
		}
	}

	//////////////////////////////////////////////////////////////////////////
	// Second, extra node features

	if (num_node_extra_fea)
	{
		if (fea_id == 2)		// For Sensor chain of supernodes 
		{
			p_node_1 = node_array + 1;
			nfp2 = node_extra_fea_para + 1;

			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				cur_pot1 = p_node_1->node_pot + 2;
				dtemp = *(*(nfp2 ++) + 1);
				*(cur_pot1 ++) += dtemp;
				*(cur_pot1 ++) += dtemp;
				dtemp *= 2;
				*(cur_pot1 ++) += dtemp;
				*(cur_pot1 ++) += dtemp;
				*cur_pot1 += dtemp;

				p_node_1 ++;
			}
		}
		else if (fea_id == 3)		// For Sensor circle of original nodes
		{
			p_node_1 = node_array + 1;
			nfp2 = node_extra_fea_para + 1;

			for (cur_item = 1; cur_item <= global_num_node; cur_item ++)
			{
				cur_pot1 = p_node_1->node_pot + 2;
				dtemp = *(*(nfp2 ++) + 1);
				*(cur_pot1 ++) += dtemp;
				*cur_pot1 += dtemp;

				p_node_1 ++;
			}
		}
	}

	//////////////////////////////////////////////////////////////////////////
	// Third Edge potentials

	p_edge = edge_array + 1;
	efp2 = edge_fea_para + 1;
	offset = 1;

	if (fea_id == 4)
	{
		rec_start = cur_step % max_delay;
		if(!rec_start)
			rec_start = max_delay;

		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)		// loop over edges
		{
			efp1 = *(efp2 ++) + 1;

			if (edge_fea_sel & 1)
			{
				for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					for (cur_class_2 = 1; cur_class_2 <= num_class; cur_class_2 ++)
					{
						p_edge->edge_pot[1][cur_class_1][cur_class_2] = *(efp1 ++);
					}
				for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					for (cur_class_2 = 1; cur_class_2 <= num_class; cur_class_2 ++)
					{
						p_edge->edge_pot[2][cur_class_1][cur_class_2] = p_edge->edge_pot[1][cur_class_2][cur_class_1];
					}
			}

			if (edge_fea_sel & 2)
			{
				if (edge_fea_sel & 1)
				{
					for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					{
						p_edge->edge_pot[1][cur_class_1][cur_class_1] += (*efp1);
						p_edge->edge_pot[2][cur_class_1][cur_class_1] = p_edge->edge_pot[1][cur_class_1][cur_class_1];
					}
				}
				else		// change += to =
				{
					for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
					{
						p_edge->edge_pot[1][cur_class_1][cur_class_1] = (*efp1);
						p_edge->edge_pot[2][cur_class_1][cur_class_1] = p_edge->edge_pot[1][cur_class_1][cur_class_1];
					}
				}
				efp1 ++;
			}

			if (cur_step > max_delay && (edge_fea_sel & 60))
			{
				node1 = p_edge->p_node[1] - node_array;
				node2 = p_edge->p_node[2] - node_array;
				cur_pot1 = p_edge->p_node[1]->node_pot + 1;
				cur_pot2 = p_edge->p_node[2]->node_pot + 1;

				cur_index = rec_start;
				for (cur_delay = min_delay; cur_delay <= max_delay; cur_delay ++, cur_index ++)
				{
					if (edge_fea_sel & 4)		// First, 1 past, 2 current (ONE feature)					
						cur_pot2[history_action[node1][cur_index]] += *(efp1 ++);

					if (edge_fea_sel & 8)		// Second, 1 past, 2 current (square matrix)
					{			
						sample = history_action[node1][cur_index];
						efp1 += (sample - 1) * num_class;
						for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
							*(cur_pot2 ++) += *(efp1 ++);
						cur_pot2 -= num_class;
						efp1 += (num_class - sample) * num_class;
					}

					if (edge_fea_sel & 16)		// Third, 1 current, 2 past (ONE feature)
						cur_pot1[history_action[node2][cur_index]] += *(efp1 ++);

					if (edge_fea_sel & 32)		// Fourth, 1 current, 2 past (square matrix)
					{				
						sample = history_action[node2][cur_index];
						efp1 += (sample - 1) * num_class;
						for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
							*(cur_pot1 ++) += *(efp1 ++);
						cur_pot1 -= num_class;
						efp1 += (num_class - sample) * num_class;
					}

					if (cur_index == max_delay)
						cur_index = 0;
				}
			}

			p_edge ++;
		}
	}
	else if (fea_id == 1)		// For Grid and Sensor circle of original nodes
	{
		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)		// loop over edges
		{

	/************************************************************************/
	/* Most General Version                                                 */
	/************************************************************************

			// loop over all classes of end_node 1
			cur_pot2_1 = p_edge->edge_pot[1] + 1;
			cur_pot2_2 = p_edge->edge_pot[2];
			p_node_1 = p_edge->p_node[1];
			for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)		
			{
				cur_pot1 = (*cur_pot2_1) + 1;

				// loop over all classes of end_node 2
				p_node_2 = p_edge->p_node[2];
				for (cur_class_2 = 1; cur_class_2 <= p_node_2->num_class; cur_class_2 ++)
				{				
					*cur_pot1 = 0;
					efp1 = (*efp2) + 1;

					// loop over all features, now only one feature
					for (cur_fea = 1; cur_fea <= num_edge_fea; cur_fea ++)
					{
						if (cur_class_1 == cur_class_2)
						{
							*cur_pot1 += *efp1;
							cur_pot2_2[cur_class_2][cur_class_1] += *efp1;
						}
					}

					cur_pot1 ++;
				}

				cur_pot2_1 ++;
			}

	/************************************************************************/
	/* Most General Version                                                 */
	/************************************************************************/


	/************************************************************************/
	/* Simplified Version                                                   */
	/************************************************************************/

			for (cur_class_1 = 1; cur_class_1 <= num_class; cur_class_1 ++)
			{
				p_edge->edge_pot[1][cur_class_1][cur_class_1] += edge_fea_intensity * (*efp2)[offset];
				p_edge->edge_pot[2][cur_class_1][cur_class_1] = p_edge->edge_pot[1][cur_class_1][cur_class_1];
			}

	/************************************************************************/
	/* Simplified Version                                                   */
	/************************************************************************/
			p_edge ++;	efp2 ++;
		}
	}
	else if (fea_id == 2)		// For Sensor with 1 chain (collective)
	{
		for (cur_item = 1; cur_item <= global_num_edge; cur_item ++)		// loop over edges
		{
			dtemp = edge_fea_intensity * (*efp2)[offset];

			p_edge->edge_pot[1][3][5] += dtemp;
			p_edge->edge_pot[1][4][5] += dtemp;
			p_edge->edge_pot[1][6][2] += dtemp;
			p_edge->edge_pot[1][6][4] += dtemp;
			p_edge->edge_pot[1][6][5] += dtemp;

			p_edge->edge_pot[2][5][3] += dtemp;
			p_edge->edge_pot[2][5][4] += dtemp;
			p_edge->edge_pot[2][2][6] += dtemp;
			p_edge->edge_pot[2][4][6] += dtemp;
			p_edge->edge_pot[2][5][6] += dtemp;

			p_edge ++;	efp2 ++;
		}
	}	
	else if (fea_id == 3)		// For Sensor circle of original nodes
	{
		// 1st, upper and lower chain
		for (cur_item = 2; cur_item < global_num_edge; cur_item ++)		
		{
			dtemp = edge_fea_intensity * (*efp2)[offset];
			p_edge->edge_pot[1][1][1] += dtemp;
			p_edge->edge_pot[1][1][3] += dtemp;
			p_edge->edge_pot[1][2][1] += dtemp;
			p_edge->edge_pot[1][2][3] += dtemp;

			p_edge->edge_pot[2][1][1] += dtemp;
			p_edge->edge_pot[2][1][2] += dtemp;
			p_edge->edge_pot[2][3][1] += dtemp;
			p_edge->edge_pot[2][3][2] += dtemp;

			dtemp = edge_fea_intensity * (*efp2)[offset + 1];
			p_edge->edge_pot[1][1][2] += dtemp;
			p_edge->edge_pot[1][2][2] += dtemp;
			p_edge->edge_pot[1][3][1] += dtemp;
			p_edge->edge_pot[1][3][3] += dtemp;

			p_edge->edge_pot[2][1][3] += dtemp;
			p_edge->edge_pot[2][2][1] += dtemp;
			p_edge->edge_pot[2][2][2] += dtemp;
			p_edge->edge_pot[2][3][3] += dtemp;

			dtemp = edge_fea_intensity * (*efp2)[offset + 2];
			p_edge->edge_pot[1][3][2] += dtemp;
			p_edge->edge_pot[2][2][3] += dtemp;

			p_edge ++;	efp2 ++;			
		}

		// 2nd, left end pairs
		dtemp = edge_fea_intensity * (*efp2)[offset];

		p_edge->edge_pot[1][1][1] += dtemp;
		p_edge->edge_pot[1][1][2] += dtemp;
		p_edge->edge_pot[1][2][1] += dtemp;
		p_edge->edge_pot[1][2][2] += dtemp;

		p_edge->edge_pot[2][1][1] += dtemp;
		p_edge->edge_pot[2][1][2] += dtemp;
		p_edge->edge_pot[2][2][1] += dtemp;
		p_edge->edge_pot[2][2][2] += dtemp;

		dtemp = edge_fea_intensity * (*efp2)[offset + 1];
		p_edge->edge_pot[1][1][3] += dtemp;
		p_edge->edge_pot[1][2][3] += dtemp;
		p_edge->edge_pot[1][3][1] += dtemp;
		p_edge->edge_pot[1][3][2] += dtemp;

		p_edge->edge_pot[2][1][3] += dtemp;
		p_edge->edge_pot[2][2][3] += dtemp;
		p_edge->edge_pot[2][3][1] += dtemp;
		p_edge->edge_pot[2][3][2] += dtemp;

		dtemp = edge_fea_intensity * (*efp2)[offset + 2];
		p_edge->edge_pot[1][3][3] += dtemp;
		p_edge->edge_pot[2][3][3] += dtemp;

		p_edge ++;	efp2 ++;	

		// 3rd, right end pairs
		dtemp = edge_fea_intensity * (*efp2)[offset];

		p_edge->edge_pot[1][1][1] += dtemp;
		p_edge->edge_pot[1][1][3] += dtemp;
		p_edge->edge_pot[1][3][1] += dtemp;
		p_edge->edge_pot[1][3][3] += dtemp;

		p_edge->edge_pot[2][1][1] += dtemp;
		p_edge->edge_pot[2][1][3] += dtemp;
		p_edge->edge_pot[2][3][1] += dtemp;
		p_edge->edge_pot[2][3][3] += dtemp;

		dtemp = edge_fea_intensity * (*efp2)[offset + 1];
		p_edge->edge_pot[1][1][2] += dtemp;
		p_edge->edge_pot[1][2][1] += dtemp;
		p_edge->edge_pot[1][2][3] += dtemp;
		p_edge->edge_pot[1][3][2] += dtemp;

		p_edge->edge_pot[2][1][2] += dtemp;
		p_edge->edge_pot[2][2][1] += dtemp;
		p_edge->edge_pot[2][2][3] += dtemp;
		p_edge->edge_pot[2][3][2] += dtemp;

		dtemp = edge_fea_intensity * (*efp2)[offset + 2];
		p_edge->edge_pot[1][2][2] += dtemp;
		p_edge->edge_pot[2][2][2] += dtemp;
	}
}


// construct trees in partitions
// ONLY determines the id of the nodes in the trees
// void define_partitions_grid()
// {
// 	int cur_part, cur_row, cur_col, next_index, cur_id, start_id, single;
// 	Tree *p_tree;
// 	Partition *p_part;
// 
// 	global_num_partition = 4;
// 	partitions = new Partition[5];
// 
// 	for (cur_part = 1;  cur_part <= 4; cur_part ++)		// for the 4 partitions
// 	{
// 		p_part = partitions + cur_part;
// 		p_part->num_trees = 2;
// 		p_part->trees = new Tree[3];
// 
// #ifdef RB_NODE_SINGLE
// 		if (cur_part == 1)
// 		{
// 			p_part->trees[1].cal_node_rb = 1;
// 			p_part->trees[2].cal_node_rb = 1;
// 		}
// 		else
// 		{
// 			p_part->trees[1].cal_node_rb = 0;
// 			p_part->trees[2].cal_node_rb = 0;
// 		}
// #else
// 		p_part->trees[1].cal_node_rb = 1;
// 		p_part->trees[2].cal_node_rb = 1;
// #endif
// 	
// 		if (cur_part == 1)
// 		{
// 			// first upper tree
// 			p_tree = p_part->trees + 1;
// 			p_tree->num_node = int((num_col + 0.1) / 2.0) * (num_row - 2) + num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 						
// 			for (next_index = 1; next_index <= num_col; next_index++)
// 				p_tree->local_to_global[next_index] = next_index;
// 
// 			start_id = cur_id = num_col + 2;
// 			for (cur_row = 2; cur_row < num_row; cur_row ++)
// 			{
// 				for (cur_col = 2; cur_col <= num_col; cur_col += 2)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += 2;
// 				}
// 				start_id += num_col;
// 				cur_id = start_id;
// 			}
// 
// 			// second lower tree
// 			p_tree = p_part->trees + 2;
// 			p_tree->num_node = int((num_col + 1.1) / 2) * (num_row - 2) + num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			next_index = 1;
// 			start_id = cur_id = num_col + 1;
// 			for (cur_row = 2; cur_row < num_row; cur_row ++)
// 			{
// 				for (cur_col = 1; cur_col <= num_col; cur_col += 2)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += 2;
// 				}
// 				start_id += num_col;
// 				cur_id = start_id;
// 			}
// 
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 				p_tree->local_to_global[next_index++] = cur_id ++;
// 		}
// 
// 		else if (cur_part == 2)
// 		{
// 			// first upper tree
// 			p_tree = p_part->trees + 1;
// 			p_tree->num_node = int((num_col + 1.1) / 2) * (num_row - 2) + num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 						
// 			for (next_index = 1; next_index <= num_col; next_index++)
// 				p_tree->local_to_global[next_index] = next_index;
// 
// 			start_id = cur_id = num_col + 1;
// 			for (cur_row = 2; cur_row < num_row; cur_row ++)
// 			{
// 				for (cur_col = 1; cur_col <= num_col; cur_col += 2)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += 2;
// 				}
// 				start_id += num_col;
// 				cur_id = start_id;
// 			}
// 
// 			// second lower tree
// 			p_tree = p_part->trees + 2;
// 			p_tree->num_node = int((num_col + 0.1) / 2.0) * (num_row - 2) + num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			next_index = 1;
// 			start_id = cur_id = num_col + 2;
// 			for (cur_row = 2; cur_row < num_row; cur_row ++)
// 			{
// 				for (cur_col = 2; cur_col <= num_col; cur_col += 2)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += 2;
// 				}
// 				start_id += num_col;
// 				cur_id = start_id;
// 			}
// 
// 			cur_id --;
// 			for (cur_col = 1; cur_col <= num_col; cur_col ++)
// 				p_tree->local_to_global[next_index++] = cur_id ++;
// 		}
// 
// 		else if (cur_part == 3)
// 		{
// 			// first left tree
// 			p_tree = p_part->trees + 1;
// 			p_tree->num_node = int((num_row + 0.1) / 2.0) * (num_col - 2) + num_row;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			single = 1;
// 			next_index = 1;
// 			cur_id = 1;
// 
// 			for (cur_row = 1; cur_row <= num_row; cur_row ++)
// 			{
// 				if (single)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += num_col;
// 				}
// 				else
// 				{
// 					for (cur_col = 1; cur_col < num_col; cur_col ++)
// 						p_tree->local_to_global[next_index++] = cur_id++;
// 					cur_id ++;
// 				}
// 
// 				single = !single;
// 			}
// 
// 			// second right tree
// 			p_tree = p_part->trees + 2;
// 			p_tree->num_node = int((num_row + 1.1) / 2) * (num_col - 2) + num_row;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			single = 0;
// 			next_index = 1;
// 			cur_id = 2;
// 
// 			for (cur_row = 1; cur_row <= num_row; cur_row ++)
// 			{
// 				if (single)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += 2;
// 				}
// 				else
// 				{					
// 					for (cur_col = 2; cur_col <= num_col; cur_col ++)
// 						p_tree->local_to_global[next_index++] = cur_id++;
// 					cur_id += num_col - 1;
// 				}
// 				
// 				single = !single;
// 			}			
// 		}
// 
// 		else if (cur_part == 4)
// 		{
// 			// first left tree
// 			p_tree = p_part->trees + 1;
// 			p_tree->num_node = int((num_row + 1.1) / 2) * (num_col - 2) + num_row;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			single = 0;
// 			next_index = 1;
// 			cur_id = 1;
// 
// 			for (cur_row = 1; cur_row <= num_row; cur_row ++)
// 			{
// 				if (single)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += num_col;
// 				}
// 				else
// 				{
// 					for (cur_col = 1; cur_col < num_col; cur_col ++)
// 						p_tree->local_to_global[next_index++] = cur_id++;
// 					cur_id ++;
// 				}
// 
// 				single = !single;
// 			}
// 
// 			// second right tree
// 			p_tree = p_part->trees + 2;
// 			p_tree->num_node = int((num_row + 0.1) / 2.0) * (num_col - 2) + num_row;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			single = 1;
// 			next_index = 1;
// 			cur_id = num_col;
// 
// 			for (cur_row = 1; cur_row <= num_row; cur_row ++)
// 			{
// 				if (single)
// 				{
// 					p_tree->local_to_global[next_index++] = cur_id;
// 					cur_id += 2;
// 				}
// 				else
// 				{					
// 					for (cur_col = 2; cur_col <= num_col; cur_col ++)
// 						p_tree->local_to_global[next_index++] = cur_id++;
// 					cur_id += num_col - 1;
// 				}
// 
// 				single = !single;
// 			}			
// 		}
// 	}
// }


// construct trees in partitions
// ONLY determines the id of the nodes in the trees
// void define_partitions_circle()
// {
// 	int cur_part, next_index, quater_floor, quater_ceil, temp;
// 	Tree *p_tree;
// 	Partition *p_part;
// 
// 	global_num_partition = 2;
// 	partitions = new Partition[3];
// 	quater_floor = int((num_col + 0.5) / 2);
// 	quater_ceil = num_col - quater_floor;
// 
// 	for (cur_part = 1;  cur_part <= 2; cur_part ++)		// for the 4 partitions
// 	{
// 		p_part = partitions + cur_part;
// 		p_part->num_trees = 2;
// 		p_part->trees = new Tree[3];
// 
// #ifdef RB_NODE_SINGLE
// 		if (cur_part == 1)
// 		{
// 			p_part->trees[1].cal_node_rb = 1;
// 			p_part->trees[2].cal_node_rb = 1;
// 		}
// 		else
// 		{
// 			p_part->trees[1].cal_node_rb = 0;
// 			p_part->trees[2].cal_node_rb = 0;
// 		}
// #else
// 		p_part->trees[1].cal_node_rb = 1;
// 		p_part->trees[2].cal_node_rb = 1;
// #endif
// 	
// 		if (cur_part == 1)
// 		{
// 			// 1st, upper tree (chain)
// 			p_tree = p_part->trees + 1;
// 			p_tree->num_node = num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			for (next_index = 1; next_index <= num_col; next_index++)
// 				p_tree->local_to_global[next_index] = next_index;
// 
// 			// 2nd, lower tree
// 			p_tree = p_part->trees + 2;
// 			p_tree->num_node = num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			for (next_index = 1; next_index <= num_col; next_index++)
// 				p_tree->local_to_global[next_index] = next_index + num_col;
// 		}
// 		else if (cur_part == 2)
// 		{
// 			// 1st, left tree
// 			p_tree = p_part->trees + 1;
// 			p_tree->num_node = num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			for (next_index = 1; next_index <= quater_floor; next_index ++)
// 				p_tree->local_to_global[next_index] = next_index;
// 			temp = num_col + 1;
// 			for (; next_index <= num_col; next_index ++, temp ++)
// 				p_tree->local_to_global[next_index] = temp;
// 
// 			// 2nd, right tree
// 			p_tree = p_part->trees + 2;
// 			p_tree->num_node = num_col;
// 			p_tree->local_to_global = new int[p_tree->num_node + 1];
// 
// 			temp = quater_floor + 1;
// 			for (next_index = 1; next_index <= quater_ceil; next_index ++, temp ++)
// 				p_tree->local_to_global[next_index] = temp;	
// 			temp = num_col + quater_ceil + 1;
// 			for (; next_index <= num_col; next_index ++, temp ++)
// 				p_tree->local_to_global[next_index] = temp;	
// 		}
// 	}
// }


// set up the parameters, the adjacency matrix
// void init_graph_grid(int *argc, char **argv)
// {
// 	Utility::get_arg(&num_row, argc, argv, "-nr", 1, 0);
// 	Utility::get_arg(&num_col, argc, argv, "-nc", 1, 0);
// 	Utility::get_arg(&global_num_node, argc, argv, "-na", 1, 0);
// 	
// 	printf("In CRF for grid, num_row = %d\tnum_col = %d\tnum_class = %d\n", num_row, num_col, num_class);
// 
// 	if (global_num_node != num_col * num_row)
// 	{
// 		cout<<"In init_graph_grid, global_num_node "<<global_num_node<<" is NOT equal to num_col * num_row ("
// 			<<num_col<<" * "<<num_row<<").  Abort."<<endl;
// 		exit(1);
// 	}
// 	
// 	global_num_edge = 2 * global_num_node - num_row - num_col;	
// 
// 	alloc_adj_matrix_grid();
// 	alloc_potentials();
// 	associate_edge_with_nodes_grid();
// 	define_partitions_grid();
// }


// set up the parameters, the adjacency matrix
// void init_graph_chain(int *argc, char **argv)
// {
// 	Utility::get_arg(&global_num_node, argc, argv, "-na", 1, 0);
// 	num_row = 1;
// 	num_col = global_num_node;
// 
// 	printf("In CRF for chain, Num Agent = %d\tNum Class = %d\n", global_num_node, num_class);
// 
// 	global_num_edge = global_num_node - 1;
// 
// 	alloc_adj_matrix_chain();
// 	alloc_potentials();
// 	associate_edge_with_nodes_chain();
// }


// set up the parameters, the adjacency matrix
// void init_graph_circle(int *argc, char **argv)
// {
// 	Utility::get_arg(&global_num_node, argc, argv, "-na", 1, 0);
// 
// 	printf("In CRF for circle, Num Agent = %d\tNum Class = %d\n", global_num_node, num_class);
// 
// 	global_num_edge = global_num_node;
// 	num_row = 2;
// 	num_col = global_num_node / 2;
// 
// 	alloc_adj_matrix_circle();
// 	alloc_potentials();
// 	associate_edge_with_nodes_circle();
// 	define_partitions_circle();
// }


// void init_graph_cross(int *argc, char **argv)
// {
// 	Utility::get_arg(&num_row, argc, argv, "-nr", 1, 0);
// 	Utility::get_arg(&num_col, argc, argv, "-nc", 1, 0);
// 	Utility::get_arg(&num_cross_upper, argc, argv, "-ncu", 1, 0);
// 	Utility::get_arg(&cross_hori_id, argc, argv, "-chi", 1, 0);
// 
// 	Utility::get_arg(&global_num_node, argc, argv, "-na", 1, 0);
// 	
// 	printf("In CRF for cross, num_row = %d\tnum_col = %d\tnum_node = %d\tnum_class = %d\tnum_cross_upper = %d\tcross_hori_id = %d\n",
// 		num_row, num_col, global_num_node, num_class, num_cross_upper, cross_hori_id);
// 	
// 	if (global_num_node != num_col + num_row - 1)
// 	{
// 		cout<<"In init_graph_cross, global_num_node "<<global_num_node<<" is NOT equal to num_col + num_row - 1 ("
// 			<<num_col<<" + "<<num_row<<" - 1).  Abort."<<endl;
// 		exit(1);
// 	}
// 
// 	global_num_edge = global_num_node - 1;	
// 
// 	alloc_adj_matrix_cross();
// 	alloc_potentials();
// 	associate_edge_with_nodes_cross();
// }


// set up the parameters, the adjacency matrix
// void init_graph(int *argc, char **argv)
// {
// 	switch(topo_id)
// 	{
// 		case 1:
// 			init_graph_chain(argc, argv);
// 			break;
// 		case 2:
// 			init_graph_grid(argc, argv);
// 			break;
// 		case 3:
// 			init_graph_circle(argc, argv);
// 			break;
// 		case 4:
// 			init_graph_cross(argc, argv);
// 			break;	
// 		default:
// 			cout<<"In init_graph, unforseen topo_id: "<<topo_id<<".  Abort."<<endl;
// 			exit(1);
// 	}
// }


// A generic sampler initializer
void init_tree_sampler(int *argc, char **argv)
{	
	int b_time, b_iter;

	Utility::get_arg(&fea_id, argc, argv, "-fid", 1, 1);
	Utility::get_arg(&topo_id, argc, argv, "-tid", 1, 1);

	if (topo_id == 2 || topo_id == 3)
	{
		b_iter = Utility::get_arg(&max_iter, argc, argv, "-i", 0, 2 << 29);
		b_time = Utility::get_arg(&max_time, argc, argv, "-t", 0, 0);

		if (b_iter && b_time)		// if both time and iter are specified, then use iter
		{
			printf("Warning, both max_iteration (%d) and max_time (%d) are specified.\n", max_iter, max_time);
			printf("Will use max_iter only.\n");
			max_time = 0;
		}
		else if (!b_iter && !b_time)		// neither max_iteration nor max_time is specified, will use default time 2000 s
		{
			printf("Neither max_iteration nor max_time is specified, will use default time 2000 ms.\n");
			max_time = 2000;
		}
		else if (b_iter)
		{
			printf("Will sample for %d iterations.\n", max_iter);
		}
		else if (b_time)
		{
			printf("Will sample for %d ms.\n", max_time);
		}	
	}

	Utility::get_arg(&num_obs_dim, argc, argv, "-no", 1, 2);
	Utility::get_arg(&num_class, argc, argv, "-ncl", 1, 2);
	Utility::get_arg(&num_edge_fea, argc, argv, "-nef", 1, 1);
	Utility::get_arg(&num_node_extra_fea, argc, argv, "-nnxf", 0, 0);
	Utility::get_arg(&edge_fea_sel, argc, argv, "-efs", 0, 0);
	Utility::get_arg(&edge_reward_def, argc, argv, "-erd", 0, 0);

	Utility::get_arg(&maxNodeRand, argc, argv, "-xn", 0, 0);
	Utility::get_arg(&maxEdgeRand, argc, argv, "-xe", 0, 0);
	Utility::get_arg(&edge_fea_intensity, argc, argv, "-et", 0, 1);

	cout<<"fea_id = "<<fea_id<<"\n"
		<<"topo_id = "<<topo_id<<"\n"
		<<"num_obs_dim = "<<num_obs_dim<<"\n"
		<<"num_class = "<<num_class<<"\n"
		<<"num_edge_fea = "<<num_edge_fea<<"\n"
		<<"num_node_extra_fea = "<<num_node_extra_fea<<"\n"
		<<"maxNodeRand = "<<maxNodeRand<<"\n"
		<<"maxEdgeRand = "<<maxEdgeRand<<"\n"
		<<"edge_fea_intensity = "<<edge_fea_intensity<<"\n";

	init_graph(argc, argv);
	alloc_fea();
	randomize_node_fea_para();
	randomize_edge_fea_para();

	Utility::get_arg(&verbosity, argc, argv, "-v", 0, 0);
	current_phase = NULL;
	cur_step = 0;
	
	if (fea_id >= 4 && fea_id <= 7)
	{
		current_phase = new int [global_num_node + 1];
		Utility::get_arg(&cycleTime, argc, argv, "-cyt", 0, -1);
		Utility::get_arg(&bias, argc, argv, "-bias", 1, 0);

		if (fabs(bias) > 1e-5)
		{
			if (cycleTime % num_class != 0)
			{
				cout<<"!! CyclicPolicyBias requires cycleTime="
					<<cycleTime
					<<" have outputs="
					<<num_class
					<<" as a factor\n";
				exit(EXIT_FAILURE);
			}
			
			stepsPerControl = cycleTime / num_class;
			cout<<"Bias = "<<bias<<"\tstepsPerControl = "<<stepsPerControl<<"\tcycleTime = "<<cycleTime<<endl;
		}
	}
	switch(topo_id)
	{
		case 1:
		case 4:
			build_ori_tree();
			break;
		case 2:
		case 3:
			build_all_trees();
			break;
		default:
			cout<<"In init_tree_sampler, unforseen topo_id: "<<topo_id<<".  Abort."<<endl;
			exit(1);
	}
	sample_buf[0] = 0;
}


/************************************************************************/
/*            Display functions for debugging                           */
/************************************************************************/


// Dump the graph parameters
// void dump_graph_specification(char * spec_file)
// {
// 	int cur_node, cur_edge, cur_class_1, cur_class_2;
// 	FILE * p_file_spec;
// 	Edge *p_edge;
// 
// 	// First output the graph parameters (topology and potentials)
// 	if(! spec_file)
// 		p_file_spec = fopen("graph_spec.dat", "w");
// 	else
// 		p_file_spec = fopen(spec_file, "w");
// 
// 	fprintf(p_file_spec, "<method> (exact_bp)\n");
// 	fprintf(p_file_spec, "<number of vertices> ( %d )\n", global_num_node);
// 	fprintf(p_file_spec, "<model type> (pairwise-discrete)\n");
// 	fprintf(p_file_spec, "<random variable sizes> ");
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		fprintf(p_file_spec, "( %d %d ) ", cur_node, node_array[cur_node].num_class);
// 	fprintf(p_file_spec, "\n");
// 
// 	// Write graph edges
// 	fprintf(p_file_spec, "<link> ");
// 	p_edge = edge_array + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		fprintf(p_file_spec, "( %d %d ) ", p_edge->p_node[1] - node_array, p_edge->p_node[2] - node_array);
// 		p_edge ++;
// 	}
// 
// 	// Write edge potentials
// 	fprintf(p_file_spec, "<potential tables> ");
// 	p_edge = edge_array + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		fprintf(p_file_spec, "( %d %d ) ", p_edge->p_node[1] - node_array, p_edge->p_node[2] - node_array);
// 		fprintf(p_file_spec, "( ");
// 		for (cur_class_1 = 1; cur_class_1 <= p_edge->p_node[1]->num_class; cur_class_1 ++)
// 		{
// 			for (cur_class_2 = 1; cur_class_2 <= p_edge->p_node[2]->num_class; cur_class_2 ++)			
// 				fprintf(p_file_spec, "%g ", pow(2, p_edge->edge_pot[2][cur_class_1][cur_class_2]));	// [2] due to a bug in PGM
// 		}
// 		fprintf(p_file_spec, ") ");
// 		p_edge ++;
// 	}
// 	fprintf(p_file_spec, "\n");
// 
// 	fprintf(p_file_spec, "<observations>\n");
// 	fprintf(p_file_spec, "<internal potentials> ");
// 
// 	// Write node potentials
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		fprintf(p_file_spec, "( %d ) ( ", cur_node);
// 		for (cur_class_1 = 1; cur_class_1 <= node_array[cur_node].num_class; cur_class_1 ++)
// 			fprintf(p_file_spec, "%g ", pow(2, node_array[cur_node].node_pot[cur_class_1]));
// 		fprintf(p_file_spec, ") ");
// 	}
// 	fprintf(p_file_spec, "\n");
// 
// 	fclose(p_file_spec);
// }


// Dump the inference results
// void dump_infer_result(char * infer_file)
// {
// 	int cur_node, cur_edge, cur_class_1, cur_class_2;
// 	FILE *p_file_infer;
// 	Edge *p_edge;
// 	
// 	if(! infer_file)
// 		p_file_infer = fopen("infer_result.dat", "w");
// 	else
// 		p_file_infer = fopen(infer_file, "w");
// 
// 	// First, dump node RB estimates
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		fprintf(p_file_infer, "Node %d:\t", cur_node);
// 		for (cur_class_1 = 1; cur_class_1 <= node_array[cur_node].num_class; cur_class_1 ++)
// 			fprintf(p_file_infer, "%g ", node_array[cur_node].rb_est[cur_class_1]);
// 		fprintf(p_file_infer, "\n");
// 	}
// 
// 	// Second, dump edge RB estimates
// 	p_edge = edge_array + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		fprintf(p_file_infer, "Edge %d: %d -> %d \n", cur_edge, p_edge->p_node[1] - node_array, p_edge->p_node[2] - node_array);
// 		for (cur_class_1 = 1; cur_class_1 <= p_edge->p_node[1]->num_class; cur_class_1 ++)
// 		{
// 			for (cur_class_2 = 1; cur_class_2 <= p_edge->p_node[2]->num_class; cur_class_2 ++)
// 				fprintf(p_file_infer, "%g ", p_edge->rb_est[cur_class_1][cur_class_2]);
// 			fprintf(p_file_infer, "\n");
// 		}
// 		p_edge ++;
// 	}
// 
// 	fclose(p_file_infer);
// }


// Output the graph and inference results to file
// void dump_graph(char * spec_file, char * infer_file)
// {
// 	dump_graph_specification(spec_file);
// 	dump_infer_result(infer_file);
// }


// Bits in selecter: (from rightmost)
// 1.  Tree structure
// 2.  Node conditionals
// 4.  Node messages
// 8.  Node sum_msg
// 16. Samples drawn
// void display_tree(Tree * cur_tree, unsigned selecter)
// {
// 	int i, j, cur_node, cur_class, cur_son;
// 	double *pd, **pd2;
// 	Node *p_node;
// 
// 	if(selecter & 1)	// 1. Tree structure
// 	{
// 		printf("Display Tree *****************\n");
// 		printf("num_node = %d\n", cur_tree->num_node);
// 
// 		printf("Nodes are (global id):\n");
// 		for (i = 1; i <= cur_tree->num_node; i ++)
// 			printf("%d\t", cur_tree->local_to_global[i]);
// 		printf("\n");
// 
// 		printf("Number of sons:\n");
// 		for (i = 1; i <= cur_tree->num_node; i ++)
// 			printf("%d\t", cur_tree->num_son[i]);
// 		printf("\n");
// 
// 		printf("Messages to pass: %d\n", cur_tree->num_node - 1);
// 		for (i = 1; i <= cur_tree->num_node - 1; i ++)
// 		{
// 			printf("%d -> %d, with order_id = %d, tree_edge %d \n",
// 				cur_tree->send[i] - node_array, cur_tree->rec[i] - node_array, cur_tree->order_id[i], 
// 				cur_tree->tree_edge[i] - edge_array);
// 		}
// 
// 		printf("Conditional Edges:\n");
// 		if(!cur_tree->cond_edge_array)	// for init_tree
// 			printf("NULL for Initial Tree.\n");
// 		else
// 		{
// 			for (i = 1; i <= cur_tree->num_node; i ++)
// 			{
// 				printf("%d) Node %d:\t", i, cur_tree->local_to_global[i]);
// 				for (j = cur_tree->cond_edge_index[i]; j < cur_tree->cond_edge_index[i+1]; j ++)
// 					printf("%d  ", cur_tree->cond_edge_array[j] - edge_array);
// 				printf("\n");
// 			}
// 		}
// 	}
// 
// 	if(selecter & 16)		// print the current sample of the tree
// 	{
// 		printf("Sample of the tree:\n");
// 		for (cur_node = 1; cur_node <= cur_tree->num_node; cur_node ++)
// 		{
// 			p_node = node_array + cur_tree->local_to_global[cur_node];
// 			printf("%d -> %d\t", cur_tree->local_to_global[cur_node], p_node->sampled_value);
// 		}
// 		printf("\n");
// 	}
// 
// 	for (cur_node = 1; cur_node <= cur_tree->num_node; cur_node ++)
// 	{
// 		p_node = node_array + cur_tree->local_to_global[cur_node];
// 
// 		if (selecter & 14)
// 			printf("Node %d:\n", cur_tree->local_to_global[cur_node]);
// 
// 		if (selecter & 2)		// 2. Node conditionals
// 		{
// 			printf("Conditionals:\n");
// 			pd = p_node->cond_pot + 1;
// 			for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 				printf("%g\t", *(pd ++));
// 			printf("\n");			
// 		}
// 		if (selecter & 4)		// 4. Node messages
// 		{
// 			printf("msg_buffer:\n");
// 			pd2 = p_node->msg_buffer + 1;
// 			for (cur_son = 1; cur_son <= p_node->num_son; cur_son ++)
// 			{
// 				pd = *(pd2 ++) + 1;
// 				for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 					printf("%g\t", *(pd ++));
// 				printf("\n");	
// 			}
// 		}
// 		if (selecter & 8)		// 8. Node sum_msg
// 		{
// 			printf("sum_msg:\n");
// 			pd = p_node->sum_msg + 1;
// 			for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
// 				printf("%g\t", *(pd ++));
// 			printf("\n");
// 		}
// 	}
// 	cin.get();
// }


// Display the potentials of all nodes and edges
// void display_pots()
// {
// 	int cur_node, cur_edge, cur_class_1, cur_class_2;
// 	double *p_pot1, **p_pot2;
// 	Node *p_node_1, *p_node_2;
// 	Edge *p_edge;
// 
// 	p_node_1 = node_array + 1;
// 	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 	{
// 		printf("Node %d:\t", cur_node);
// 		p_pot1 = p_node_1->node_pot + 1;
// 		for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
// 			printf("%g\t", *(p_pot1 ++));
// 		p_node_1 ++;
// 		printf("\n");
// 	}
// 
// 	p_edge = edge_array + 1;
// 	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 	{
// 		p_node_1 = p_edge->p_node[1];
// 		p_node_2 = p_edge->p_node[2];
// 
// 		printf("Edge %d:  %d -> %d\n", cur_edge, p_edge->p_node[1] - node_array, p_edge->p_node[2] - node_array);
// 		
// 		p_pot2 = p_edge->edge_pot[1] + 1;
// 
// 		for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
// 		{
// 			p_pot1 = *(p_pot2 ++) + 1;
// 			for (cur_class_2 = 1; cur_class_2 <= p_node_2->num_class; cur_class_2 ++)
// 			{
// 				printf("%g\t", *(p_pot1 ++));
// 			}
// 
// 			printf("\n");
// 		}
// 		p_edge ++;
// 	}
// }


// Display the RB estimates of the graph, including nodes and edges
// void display_RB()
// {
// 	int cur_node, cur_edge, cur_class_1, cur_class_2;
// 	double *pd1, **pd2;
// 	Node *p_node_1, *p_node_2;
// 	Edge *p_edge;
// 
// 	if (verbosity & 2)
// 	{
// 		printf("===========================================\n");
// 		// First, Node RBs
// 		printf("Node RB Estimates:\n");
// 		p_node_1 = node_array + 1;
// 		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
// 		{
// 			printf("Node %d:\t", cur_node);
// 			pd1 = p_node_1->rb_est + 1;
// 			for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
// 				printf("%g\t", *(pd1 ++));
// 			p_node_1 ++;
// 			printf("\n");
// 		}
// 	}
// 
// 	if(verbosity & 4)
// 	{
// 		// Second, Edge RBs
// 		printf("-------------------------------------------\n");
// 		printf("Edge RB Estimates:\n");
// 		p_edge = edge_array + 1;
// 		for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
// 		{
// 			p_node_1 = p_edge->p_node[1];
// 			p_node_2 = p_edge->p_node[2];
// 			printf("Edge %d:\t%d -> %d\n", cur_edge, p_node_1 - node_array, p_node_2 - node_array);
// 
// 			pd2 = p_edge->rb_est + 1;
// 			for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
// 			{
// 				pd1 = *(pd2 ++) + 1;
// 				for (cur_class_2 = 1; cur_class_2 <= p_node_2->num_class; cur_class_2 ++)
// 					printf("%g\t", *(pd1 ++));
// 				printf("\n");
// 			}
// 
// 			p_edge ++;
// 		}
// 	}
// 	cin.get();
// }

  
/*


//***************************************

// Bits in selecter: (from rightmost)
// 1.  Tree structure
// 2.  Node conditionals
// 4.  Node messages
// 8.  Node sum_msg
// 16. Samples drawn
void display_tree(Tree * cur_tree, unsigned selecter)
{
	int i, j, cur_node, cur_class, cur_son;
	double *pd, **pd2;
	Node *p_node;

	FILE *fp;
	fp = fopen("history.dat", "a");

	if(selecter & 1)	// 1. Tree structure
	{
		fprintf(fp, "Display Tree *****************\n");
		fprintf(fp, "num_node = %d\n", cur_tree->num_node);

		fprintf(fp, "Nodes are (global id):\n");
		for (i = 1; i <= cur_tree->num_node; i ++)
			fprintf(fp, "%d\t", cur_tree->local_to_global[i]);
		fprintf(fp, "\n");

		fprintf(fp, "Number of sons:\n");
		for (i = 1; i <= cur_tree->num_node; i ++)
			fprintf(fp, "%d\t", cur_tree->num_son[i]);
		fprintf(fp, "\n");

		fprintf(fp, "Messages to pass: %d\n", cur_tree->num_node - 1);
		for (i = 1; i <= cur_tree->num_node - 1; i ++)
		{
			fprintf(fp, "%d -> %d, with order_id = %d, tree_edge %d \n",
				cur_tree->send[i] - node_array, cur_tree->rec[i] - node_array, cur_tree->order_id[i], 
				cur_tree->tree_edge[i] - edge_array);
		}

		fprintf(fp, "Conditional Edges:\n");
		if(!cur_tree->cond_edge_array)	// for init_tree
			fprintf(fp, "NULL for Initial Tree.\n");
		else
		{
			for (i = 1; i <= cur_tree->num_node; i ++)
			{
				fprintf(fp, "%d) Node %d:\t", i, cur_tree->local_to_global[i]);
				for (j = cur_tree->cond_edge_index[i]; j < cur_tree->cond_edge_index[i+1]; j ++)
					fprintf(fp, "%d  ", cur_tree->cond_edge_array[j] - edge_array);	// (%d) // , cur_tree->cond_edge_orient[j]
				fprintf(fp, "\n");
			}
		}
	}

	if(selecter & 16)
	{
		fprintf(fp, "Sample of the tree:\n");
		for (cur_node = 1; cur_node <= cur_tree->num_node; cur_node ++)
		{
			p_node = node_array + cur_tree->local_to_global[cur_node];
			fprintf(fp, "%d -> %d\t", cur_tree->local_to_global[cur_node], p_node->sampled_value);
		}
		fprintf(fp, "\n");
	}

	for (cur_node = 1; cur_node <= cur_tree->num_node; cur_node ++)
	{
		p_node = node_array + cur_tree->local_to_global[cur_node];

		if (selecter & 14)
			fprintf(fp, "Node %d:\n", cur_tree->local_to_global[cur_node]);

		if (selecter & 2)		// 2. Node conditionals
		{
			fprintf(fp, "Conditionals:\n");
			pd = p_node->cond_pot + 1;
			for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
				fprintf(fp, "%g\t", *(pd ++));
			fprintf(fp, "\n");			
		}
		if (selecter & 4)		// 4. Node messages
		{
			fprintf(fp, "msg_buffer:\n");
			pd2 = p_node->msg_buffer + 1;
			for (cur_son = 1; cur_son <= p_node->num_son; cur_son ++)
			{
				pd = *(pd2 ++) + 1;
				for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
					fprintf(fp, "%g\t", *(pd ++));
				fprintf(fp, "\n");	
			}
		}
		if (selecter & 8)		// 8. Node sum_msg
		{
			fprintf(fp, "sum_msg:\n");
			pd = p_node->sum_msg + 1;
			for (cur_class = 1; cur_class <= p_node->num_class; cur_class ++)
				fprintf(fp, "%g\t", *(pd ++));
			fprintf(fp, "\n");
		}
	}
	fclose(fp);
}


// Display the potentials of all nodes and edges
void display_pots()
{
	int cur_node, cur_edge, cur_class_1, cur_class_2;
	double *p_pot1, **p_pot2;
	Node *p_node_1, *p_node_2;
	Edge *p_edge;

	FILE *fp;
	fp = fopen("history.dat", "a");

	p_node_1 = node_array + 1;
	for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
	{
		fprintf(fp, "Node %d:\t", cur_node);
		p_pot1 = p_node_1->node_pot + 1;
		for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
			fprintf(fp, "%g\t", *(p_pot1 ++));
		p_node_1 ++;
		fprintf(fp, "\n");
	}

	p_edge = edge_array + 1;
	for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
	{
		p_node_1 = p_edge->p_node[1];
		p_node_2 = p_edge->p_node[2];

		fprintf(fp, "Edge %d:  %d -> %d\n", cur_edge, p_edge->p_node[1] - node_array, p_edge->p_node[2] - node_array);
		
		p_pot2 = p_edge->edge_pot[1] + 1;

		for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
		{
			p_pot1 = *(p_pot2 ++) + 1;
			for (cur_class_2 = 1; cur_class_2 <= p_node_2->num_class; cur_class_2 ++)
			{
				fprintf(fp, "%g\t", *(p_pot1 ++));
			}

			fprintf(fp, "\n");
		}
		p_edge ++;
	}

	fclose(fp);
}


// Display the RB estimates of the graph, including nodes and edges
void display_RB()
{
	int cur_node, cur_edge, cur_class_1, cur_class_2;
	double *pd1, **pd2;
	Node *p_node_1, *p_node_2;
	Edge *p_edge;

	FILE *fp;
	fp = fopen("history.dat", "a");

	if (verbosity & 2)
	{
		fprintf(fp, "===========================================\n");
		// First, Node RBs
		fprintf(fp, "Node RB Estimates:\n");
		p_node_1 = node_array + 1;
		for (cur_node = 1; cur_node <= global_num_node; cur_node ++)
		{
			fprintf(fp, "Node %d:\t", cur_node);
			pd1 = p_node_1->rb_est + 1;
			for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
				fprintf(fp, "%g\t", *(pd1 ++));
			p_node_1 ++;
			fprintf(fp, "\n");
		}
	}

	if(verbosity & 4)
	{
		// Second, Edge RBs
		fprintf(fp, "-------------------------------------------\n");
		fprintf(fp, "Edge RB Estimates:\n");
		p_edge = edge_array + 1;
		for (cur_edge = 1; cur_edge <= global_num_edge; cur_edge ++)
		{
			p_node_1 = p_edge->p_node[1];
			p_node_2 = p_edge->p_node[2];
			fprintf(fp, "Edge %d:\t%d -> %d\n", cur_edge, p_node_1 - node_array, p_node_2 - node_array);

			pd2 = p_edge->rb_est + 1;
			for (cur_class_1 = 1; cur_class_1 <= p_node_1->num_class; cur_class_1 ++)
			{
				pd1 = *(pd2 ++) + 1;
				for (cur_class_2 = 1; cur_class_2 <= p_node_2->num_class; cur_class_2 ++)
					fprintf(fp, "%g\t", *(pd1 ++));
				fprintf(fp, "\n");
			}

			p_edge ++;
		}
	}

	fclose(fp);
}
*/


// The main file for testing
int main_test_tree(int *argc, char **argv)
{	
	init_tree_sampler(argc, argv);

	////////////////////////
	// These will be done repeatedly
	set_cur_obs_debug();
	set_node_fea_para_debug();
	set_edge_fea_para_debug();
	set_potentials();
	////////////////////////

	if (verbosity & 8)
		display_pots();		// for debug

	infer_graph();		// calculate the RB estimation

	cal_fea_expectation();

	return 0;
}

}
